<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class SmPropostasAlimentacaoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    public function getPropostasAlimentacao()
    {
        $sql = "SELECT 
                     o.NRSEQORCAMENTO, 
                     o.NRPARCNEGOCIO,
                     o.CDFILIAL,
                     o.NRORCAMENTO,
                     o.NRVERSAOORCAMENTO,
                     o.CDFILICONTATO,
                     o.NRCONTATO,
                     o.NRTIPOORCAMENTO,
                     o.NRPARCTRANSPORTADORA,
                     o.DTREFORCAMENTO,
                     o.CDPRECBASESERV,
                     o.CDREDUCONT,
                     o.IDFATURAORCA,
                     o.CDMODPGTO,
                     o.NRPARCINTERLOCUTOR,
                     o.NRGRUPOFATURA,
                     o.DSREFERENCIAORCA,
                     o.IDTRANSPORTADORA,
                     o.QTDIASVALIDADE,
                     o.DTVALIDADE,
                     o.QTDIASCONTRATO,
                     o.DTINICIOCONTRATO,
                     o.DTFIMCONTRATO,
                     o.NMPRINCIPALPARC,
                     o.DSEMAIL,
                     o.NMPARCINTERLOCUTOR,
                     o.NRTELEFONE,
                     o.DSOBSERVACAOORCA,
                     o.IDGERACONTRATO,
                     o.IDSITUACAOORCAMENTO,
                     o.VRORCAMENTO,
                     o.NRSEQORCAMENTOPAI,
                     o.CDSEQORCAMENTO,
                     o.NRORG,
                     o.IDATIVO,
                     o.DTINCLUSAO,
                     o.DTULTATU,
                     o.NRORGINCLUSAO,
                     o.CDOPERINCLUSAO,
                     o.NRORGULTATU,
                     o.CDOPERULTATU,
                     o.DSINTERORCA,
                     o.NRORCAMENTOMODELO,
                     om.NMORCAMENTOMODELO, 
                     es.NMTIPOORCAMENTO,
                     o.DTACEITEORCA,
                     o.NRSEQCONTATO,
                     o.NRSEQOPORT,
                     o.IDORCAFILHO,
                     o.NRORCAMENTORELAC,
                     o.NRDIASCARENCIA,
                     o.QTPARCELASFATU,
                     o.NRDIAVENCPARCELASFATU,
                     o.NRSEQINTERLOCUTOR,
                     o.CDOPERRESPONSAVEL,
                     o.IDPRODUTO,
                     o.DSJUSTIFCANCRENEG,
                     o.VRPERCMARKUP,
                     o.IDPROPALIMENTICIA,
                     o.VRPERCMARKUPAPLICADO,
                     o.NRSOLISERV,
                     o.DSALTERACONTRATUAIS,
                     o.IDASSELETRDIGITAL,
                     o.ISSUEID,
                     o.IDENVIADOCOPERRESPCONCASS,
                     o.JSONOMVALIDATEELEMENTS,
                     o.CDIDIOM,
                     o.NRMOEDA,
                     o.NRPARCINTERLOCUTORFAT,
                     o.NRREVENDA 
                 FROM fct_orcamento o
                 LEFT JOIN fct_orcamentomodelo om ON o.NRORCAMENTOMODELO = om.NRORCAMENTOMODELO
                 LEFT JOIN FCT_TIPOORCAMENTO es ON es.NRTIPOORCAMENTO = o.NRTIPOORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getElementosComposicaoServico()
    {
        $sql = "SELECT DISTINCT IDELEMENTO,
                    IDELEMENTOPAI,
                    IDTIPOELEMENTO,
                    CDTPMEDIDAVARIAVEL,
                    CDELEMENTO,
                    CDSERVORCARELAC,
                    NMSERVORCARELAC,
                    NRTIPOORCAMENTO,
                    NMTIPOORCAMENTO,
                    IDALTQTDMEDIDAPROP,
                    IDFATURACONTR,
                    CDMODPGTO,
                    NRGRUPOFATURA,
                    QTPARCELASFATU,
                    NRDIAVENCPARCELASFATU,
                    IDUTILIZAVARPRECO,
                    CDTPMEDIDASERV,
                    QTMEDIDASERV,
                    VRUNITARIO,
                    VRPRECO,
                    DTFIMVALPBSERV,
                    NRORG,
                    NULL AS QTMEDIDAVARIAVEL,
                    IDELEMENTORAIZ,
                    NMELEMENTO,
                    0 AS VRCUSTOSERV,
                    NRCOMPSERVICO,
                    '00:00' AS HRENTRADA,
                    '00:00' AS HRSAIDA,
                    0 AS QTDOMINGO,
                    0 AS QTSABADO,
                    0 AS QTMENSAL,
                    0 AS QTSEGUNDA,
                    0 AS QTTERCA,
                    0 AS QTQUARTA,
                    0 AS QTQUINTA,
                    0 AS QTSEXTA,
                    0 AS QTDIAUTIL,
                    0 AS QTFIMSEMANA
                    FROM (SELECT DISTINCT COMPOSICAO.IDELEMENTO,
                         COMPOSICAO.IDELEMENTOPAI,
                         COMPOSICAO.IDTIPOELEMENTO,
                         COMPOSICAO.CDTPMEDIDAVARIAVEL,
                         COMPOSICAO.CDELEMENTO,
                         COMPOSICAO.CDSERVORCARELAC,
                         COMPOSICAO.NMSERVORCARELAC,
                         COMPOSICAO.NRTIPOORCAMENTO,
                         COMPOSICAO.NMTIPOORCAMENTO,
                         COMPOSICAO.IDALTQTDMEDIDAPROP,
                         COMPOSICAO.IDFATURACONTR,
                         COMPOSICAO.CDMODPGTO,
                         COMPOSICAO.NRGRUPOFATURA,
                         COMPOSICAO.QTPARCELASFATU,
                         COMPOSICAO.NRDIAVENCPARCELASFATU,
                         COMPOSICAO.IDUTILIZAVARPRECO,
                         COMPOSICAO.CDTPMEDIDASERV,
                         COMPOSICAO.QTMEDIDASERV,
                         COMPOSICAO.VRPRECO AS VRUNITARIO,
                         COMPOSICAO.VRPRECO * COMPOSICAO.QTMEDIDASERV AS VRPRECO,
                         TO_CHAR(COMPOSICAO.DTFIMVALPBSERV, 'DD/MM/YYYY') AS DTFIMVALPBSERV,
                         COMPOSICAO.NRORG,
                         COMPOSICAO.IDELEMENTORAIZ,
                         COMPOSICAO.NRCOMPSERVICO,
                         ELE.NMSERVORCA AS NMELEMENTO
                        FROM (SELECT DISTINCT ITEM.NRCOMPSERVICO,
                             ITEM.IDELEMENTO,
                             ITEM.IDELEMENTOPAI,
                             ELEMENTO.IDTIPOELEMENTO,
                             ELEMENTO.CDTPMEDIDAVARIAVEL,
                             ITEM.CDSERVORCA AS CDELEMENTO,
                             ITEM.IDSERVOBRIGCOMP,
                             SERVRELAC.CDSERVORCARELAC,
                             SERVICO.NMSERVORCA AS NMSERVORCARELAC,
                             ITESCOPO.NRTIPOORCAMENTO,
                             ESCOPO.NMTIPOORCAMENTO,
                             ESCOPO.IDALTQTDMEDIDAPROP,
                             ESCOPO.IDUTILIZAVARPRECO,
                             DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.IDFATURACONTR, PARAMSRV.IDFATURACONTR) AS IDFATURACONTR,
                             DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.CDMODPGTO, PARAMSRV.CDMODPGTO) AS CDMODPGTO,
                             DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.NRGRUPOFATURA, PARAMSRV.NRGRUPOFATURA) AS NRGRUPOFATURA,
                             DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.QTPARCELASFATU, PARAMSRV.QTPARCELASFATU) AS QTPARCELASFATU,
                             DECODE(PARAMSRV.NRSEQFATUSRVESCO, NULL, PARAMESC.NRDIAVENCPARCELASFATU, PARAMSRV.NRDIAVENCPARCELASFATU) AS NRDIAVENCPARCELASFATU,
                             ITPRECO.CDTPMEDIDASERV,
                             DECODE(ITPRECO.VRPRECO, NULL, NULL, SERVRELAC.QTMEDIDASERV) AS QTMEDIDASERV,
                             ITPRECO.VRPRECO,
                             ITPRECO.DTFIMVALPBSERV,
                             ITEM.NRORG,
                             (SELECT DISTINCT IDELEMENTO
                                   FROM FCT_ITCOMPSERVICO
                                  WHERE NRCOMPSERVICO = ITEM.NRCOMPSERVICO
                                    AND CONNECT_BY_ISLEAF = 1
                                CONNECT BY PRIOR IDELEMENTOPAI = IDELEMENTO
                                    AND PRIOR NRCOMPSERVICO = ITEM.NRCOMPSERVICO
                                  START WITH IDELEMENTO = ITEM.IDELEMENTO) AS IDELEMENTORAIZ
                        FROM FCT_ITCOMPSERVICO ITEM
                        LEFT JOIN FCT_RELACSERVICO SERVRELAC
                            ON ITEM.CDSERVORCA = SERVRELAC.CDSERVORCA
                            AND ITEM.NRORG      = SERVRELAC.NRORG
                        LEFT JOIN FCT_SERVICOORCA SERVICO
                            ON SERVRELAC.CDSERVORCARELAC = SERVICO.CDSERVORCA
                            AND SERVRELAC.NRORG           = SERVICO.NRORG
                        LEFT JOIN FCT_SERVICOORCA ELEMENTO
                            ON ITEM.CDSERVORCA      = ELEMENTO.CDSERVORCA
                            AND ITEM.NRORG           = ELEMENTO.NRORG 
                        LEFT JOIN FCT_ITESCOPOPROPOSTA ITESCOPO
                            ON SERVRELAC.CDSERVORCARELAC = ITESCOPO.CDSERVORCA
                            AND SERVRELAC.NRORG           = ITESCOPO.NRORG
                            AND ITESCOPO.NRTIPOORCAMENTO = ITESCOPO.NRTIPOORCAMENTO
                        LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                            ON ITESCOPO.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
                            AND ITESCOPO.NRORG           = ESCOPO.NRORG
                        LEFT JOIN FCT_PARAMFATESCOPO PARAMESC
                            ON ESCOPO.NRTIPOORCAMENTO = PARAMESC.NRTIPOORCAMENTO
                            AND ESCOPO.NRORG           = PARAMESC.NRORG
                        LEFT JOIN FCT_PARAMFATSRVESCO PARAMSRV
                            ON ITESCOPO.NRITESCOPOPROPOSTA = PARAMSRV.NRITESCOPOPROPOSTA
                            AND ITESCOPO.NRORG              = PARAMSRV.NRORG
                        LEFT JOIN FCT_ITPRECBASESERV ITPRECO
                            ON ESCOPO.CDPRECBASESERV = ITPRECO.CDPRECBASESERV
                            AND ESCOPO.NRORG          = ITPRECO.NRORG
                            AND ITESCOPO.CDSERVORCA   = ITPRECO.CDSERVORCA
                            WHERE ITEM.NRCOMPSERVICO = ITEM.NRCOMPSERVICO
                          AND ITEM.NRORG = :NRORG
                          AND TRUNC(NVL(ITPRECO.DTINIPBSERV,SYSDATE)) <= TRUNC(SYSDATE)) COMPOSICAO
                    LEFT JOIN FCT_SERVICOORCA ELE
                        ON COMPOSICAO.IDELEMENTO = ELE.IDELEMENTO
                        AND COMPOSICAO.NRORG     = ELE.NRORG)
                    order by IDELEMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getElementosComposicaoServicoSemNrComposicao()
    {
        $sql = "SELECT CDSERVORCARELAC,
    NMSERVORCARELAC,
    IDELEMENTORAIZ,
    IDELEMENTOPAI,
    IDELEMENTO, 
    NMELEMENTO,
    VRCUSTOSERV,
    LISTAGG(NRCOMPSERVICO, '_') WITHIN GROUP(ORDER BY NRCOMPSERVICO) AS NRCOMPSERVICO
FROM (SELECT DECODE(NVL(CDSERVORCARELAC, -1), -1, NULL, IDELEMENTORAIZ) AS IDELEMENTOPAI,
        CASE 
          WHEN CDSERVORCARELAC IS NULL THEN IDELEMENTORAIZ
          ELSE IDELEMENTORAIZ || '_' || CDSERVORCARELAC
        END AS IDELEMENTO,
        CDSERVORCARELAC,
        NMSERVORCARELAC,
        IDELEMENTORAIZ,
        NRCOMPSERVICO,
        0 AS VRCUSTOSERV,
        SERVRAIZ.NMSERVORCA AS NMELEMENTO
      FROM (SELECT DISTINCT SERVRELAC.CDSERVORCARELAC,
                   SERVICO.NMSERVORCA AS NMSERVORCARELAC,
                   (SELECT DISTINCT IDELEMENTO
                       FROM FCT_ITCOMPSERVICO
                      WHERE NRCOMPSERVICO = ITEM.NRCOMPSERVICO
                        AND CONNECT_BY_ISLEAF = 1
                    CONNECT BY PRIOR IDELEMENTOPAI = IDELEMENTO
                        AND PRIOR NRCOMPSERVICO = ITEM.NRCOMPSERVICO
                      START WITH IDELEMENTO = ITEM.IDELEMENTO) AS IDELEMENTORAIZ,
                ITEM.NRCOMPSERVICO  
                FROM FCT_ITCOMPSERVICO ITEM
                LEFT JOIN FCT_RELACSERVICO SERVRELAC
                  ON ITEM.CDSERVORCA = SERVRELAC.CDSERVORCA
                LEFT JOIN FCT_SERVICOORCA SERVICO
                  ON SERVRELAC.CDSERVORCARELAC = SERVICO.CDSERVORCA
            INNER JOIN FCT_ITESCOPOPROPOSTA ITESCOPO
                ON SERVRELAC.CDSERVORCARELAC = ITESCOPO.CDSERVORCA
            WHERE ITESCOPO.NRTIPOORCAMENTO = ITESCOPO.NRTIPOORCAMENTO
              AND ITEM.NRCOMPSERVICO = ITEM.NRCOMPSERVICO) ELESERVORCA
      LEFT JOIN FCT_SERVICOORCA SERVRAIZ
        ON ELESERVORCA.IDELEMENTORAIZ = SERVRAIZ.IDELEMENTO) ELEMENTO
GROUP BY CDSERVORCARELAC,
     NMSERVORCARELAC,
     IDELEMENTORAIZ,
     IDELEMENTOPAI,
     IDELEMENTO,
     NMELEMENTO,
     VRCUSTOSERV
ORDER BY IDELEMENTORAIZ";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

   public function getEscopoFaturamentoProposta($params)
    {
        // Evitar SQL Injection


        $sql = " SELECT * 
                FROM    FCT_TIPOORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }



    public function getMaoDeObraQuant($params)
    {
        $sql = "SELECT 
    FORMPROP.NRRELACFORMACAOPROP,
    FORMPROP.NRFORMPRECOSERVICO,
    FORMP.NMFORMPRECOSERVICO,
    FORMP.CDSERVORCA,
    SERV.NMSERVORCA,
    DSSINDICATO,
    VRFORM.VRTOTAL AS VRUNITARIO,
    (FORMPROP.QTFORMACAOPROP * VRFORM.VRTOTAL) AS VRTOTAL,
    FORMPROP.NRITEMORCAMENTO,
    FORMPROP.QTFORMACAOPROP
FROM 
    FCT_RELACFORMACAOPROP FORMPROP
INNER JOIN 
    FCT_FORMPRECOSERVICO FORMP 
    ON FORMPROP.NRFORMPRECOSERVICO = FORMP.NRFORMPRECOSERVICO
INNER JOIN 
    FCT_SERVICOORCA SERV 
    ON FORMPROP.CDSERVORCARELAC = SERV.CDSERVORCA
LEFT JOIN 
    (
        SELECT 
            SUM(ITAUXFORM.VRTOTAL) VRTOTAL,
            ITAUXFORM.NRFORMPRECOSERVICO,
            ITAUXFORM.NRSEQORCAMENTO,
            ITAUXFORM.NRRELACFORMACAOPROP
        FROM 
            FCT_CALCFORMPRECSERV_ITPRO ITAUXFORM
        INNER JOIN 
            FCT_RELACFORMACAOPROP FORMPROP 
            ON ITAUXFORM.NRFORMPRECOSERVICO = FORMPROP.NRFORMPRECOSERVICO
            AND ITAUXFORM.NRRELACFORMACAOPROP = FORMPROP.NRRELACFORMACAOPROP
        WHERE 
            NRCALCFORMPRECSERVPAI IS NULL 
            AND FORMPROP.NRSEQORCAMENTO = :NRSEQORCAMENTO
        GROUP BY 
            ITAUXFORM.NRFORMPRECOSERVICO, 
            ITAUXFORM.NRSEQORCAMENTO, 
            ITAUXFORM.NRRELACFORMACAOPROP
    ) VRFORM 
    ON VRFORM.NRSEQORCAMENTO = FORMPROP.NRSEQORCAMENTO 
    AND VRFORM.NRFORMPRECOSERVICO = FORMPROP.NRFORMPRECOSERVICO 
    AND VRFORM.NRRELACFORMACAOPROP = FORMPROP.NRRELACFORMACAOPROP
WHERE 
    FORMPROP.NRSEQORCAMENTO = :NRSEQORCAMENTO 
ORDER BY 
    NMFORMPRECOSERVICO";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getMaodeObra($params)
    {
        $sql = "SELECT
                    r.NRRELACFORMACAOPROP,
                    r.NRFORMPRECOSERVICO,
                    f.NMFORMPRECOSERVICO, -- Pegando o nome da tabela relacionada
                    r.NRSEQORCAMENTO,
                    r.NRITEMORCAMENTO,
                    r.NRORG,
                    r.IDATIVO,
                    r.DTINCLUSAO,
                    r.DTULTATU,
                    r.NRORGINCLUSAO,
                    r.CDOPERINCLUSAO,
                    r.NRORGULTATU,
                    r.CDOPERULTATU,
                    r.QTFORMACAOPROP,
                    r.CDSERVORCARELAC
                FROM FCT_RELACFORMACAOPROP r
                LEFT JOIN FCT_FORMPRECOSERVICO f ON r.NRFORMPRECOSERVICO = f.NRFORMPRECOSERVICO
                WHERE r.NRSEQORCAMENTO = :NRSEQORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getInvestimentos()
    {
        $sql = "SELECT 
                     NRINVESTIMENTO,
                     DSINVESTIMENTO,
                     DTINCLUSAO,
                     NRORG,
                     DTULTATU,
                     NRORGINCLUSAO,
                     CDOPERINCLUSAO,
                     NRORGULTATU,
                     CDOPERULTATU,
                     IDATIVO
                 FROM FCT_INVESTIMENTO";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getDespesas()
    {
        $sql = "SELECT * 
                 FROM FCT_DESPESA";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getDespesasPropostaAlimentacao($params)
    {
        $sql = "SELECT NRDESPPROP, NRSEQORCAMENTO, CDDESPESA, VRDESPESAORCA, VRUNITDESPESA, CDPERIODODESPPROP
                FROM FCT_RELACDESPPROPOSTA
                WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";

        // Certificando-se de que o parâmetro está sendo passado corretamente
        $parametros = [
            'NRSEQORCAMENTO' => $params['NRSEQORCAMENTO'] ?? null, // Ou algum valor padrão, se necessário
        ];

        // Passando os parâmetros para a execução da consulta
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }


    public function getImpostos()
    {
        $sql = "SELECT 
        rel.NRIMPOSTOSERV, 
        rel.NRCOMPSERVICO, 
        rel.CDIMPOSTO, 
        rel.VRPRECIMPOSTO,
        imp.NMIMPOSTO, 
        rel.IDATIVO, 
        rel.NRORG 
    FROM FCT_RELACIMPOSTOSERV rel
    LEFT JOIN IMPOSTO imp ON rel.CDIMPOSTO = imp.CDIMPOSTO";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getImpostosPropostaAlimentacao($params)
    {
        // Verifica se o parâmetro 'NRSEQORCAMENTO' foi fornecido
        if (isset($params['NRSEQORCAMENTO']) && !empty($params['NRSEQORCAMENTO'])) {
            // SQL com filtro para NRSEQORCAMENTO
            $sql = "SELECT 
                        rel.NRIMPOSTOORCA, 
                        rel.NRSEQORCAMENTO, 
                        rel.CDIMPOSTO, 
                        imp.NMIMPOSTO, 
                        rel.VRPERCIMPOSTO, 
                        rel.NRORG, 
                        rel.DTINCLUSAO, 
                        rel.DTULTATU, 
                        rel.NRORGINCLUSAO, 
                        rel.CDOPERINCLUSAO, 
                        rel.NRORGULTATU, 
                        rel.CDOPERULTATU, 
                        rel.IDATIVO
                    FROM FCT_RELACIMPOSTOORCA rel
                    LEFT JOIN IMPOSTO imp ON rel.CDIMPOSTO = imp.CDIMPOSTO
                    WHERE rel.NRSEQORCAMENTO = :NRSEQORCAMENTO"; // Adiciona o filtro

            // Passa o parâmetro 'NRSEQORCAMENTO' para a consulta
            $params = ['NRSEQORCAMENTO' => $params['NRSEQORCAMENTO']];
        }
        // Executa a consulta com os parâmetros fornecidos
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getTabServicosPropostas(array $params)
    {
        $sql = "SELECT 
                    TO_CHAR(COMP.NRCOMPSERVICO) AS IDARVORE, 
                    TO_CHAR(COMP.NRCOMPSERVICOPAI) AS IDARVOREPAI, 
                    COMP.NRCOMPSERVICO, 
                    COMP.NRCOMPSERVICO AS CDELEMENTO, 
                    COMP.NMCOMPSERVICO AS NMELEMENTO, 
                    NULL AS IDTIPOELEMENTO, 
                    -1 AS IDORDENAELEMENTO, 
                    NULL AS CDTPMEDIDAVARIAVEL, 
                    TO_CHAR(COMP.NRCOMPSERVICO) AS IDELEMENTO, 
                    NULL AS IDELEMENTOPAI, 
                    COMP.IDCOMPOBRIGATORIA AS IDSERVOBRIGCOMP, 
                    COMP.NRORG, 

                    'N' AS IDESCOLHIDO, 
                    'C' AS TIPO, 
                    0 AS QTSEGUNDA, 
                    0 AS QTTERCA, 
                    0 AS QTQUARTA, 
                    0 AS QTQUINTA, 
                    0 AS QTSEXTA, 
                    0 AS QTDOMINGO, 
                    0 AS QTSABADO, 
                    0 AS QTMENSAL, 
                    '00:00' AS HRENTRADA, 
                    '00:00' AS HRSAIDA, 
                    0 AS QTFIMSEMANA, 
                    0 AS QTDIAUTIL 
                FROM 
                    FCT_COMPSERVICO COMP
                JOIN 
                    FCT_RELORCAMODCOMPOSICAO MODELO 
                    ON COMP.NRCOMPSERVICO = MODELO.NRCOMPSERVICO 
                    AND COMP.NRORG = MODELO.NRORG 
                    AND MODELO.NRORCAMENTOMODELO = :NRORCAMENTOMODELO
                JOIN 
                    FCT_RELACESCOPOMODELO MODEESCOPO 
                    ON MODELO.NRORCAMENTOMODELO = MODEESCOPO.NRORCAMENTOMODELO 
                    AND MODELO.NRORG = MODEESCOPO.NRORG 
                    AND MODEESCOPO.NRTIPOORCAMENTO IN (:NRTIPOORCAMENTO)
                WHERE 
                    (SELECT COUNT(*) 
                     FROM FCT_ITCOMPSERVICO ITCOMP 
                     JOIN FCT_RELACSERVICO SERV 
                     ON ITCOMP.CDSERVORCA = SERV.CDSERVORCA 
                     AND ITCOMP.NRORG = SERV.NRORG 
                     JOIN FCT_ITESCOPOPROPOSTA ITESCOPO 
                     ON SERV.CDSERVORCARELAC = ITESCOPO.CDSERVORCA 
                     AND SERV.NRORG = ITESCOPO.NRORG 
                     WHERE ITCOMP.NRCOMPSERVICO = COMP.NRCOMPSERVICO) > 0
    
                UNION ALL
    
                SELECT DISTINCT 
                    TO_CHAR(NRCOMPSERVICO) || '_' || IDELEMENTO AS IDARVORE, 
                    DECODE(IDELEMENTOPAI, NULL, TO_CHAR(NRCOMPSERVICO), TO_CHAR(NRCOMPSERVICO) || '_' || IDELEMENTOPAI) AS IDARVOREPAI, 
                    NRCOMPSERVICO, 
                    CDELEMENTO, 
                    NMELEMENTO, 
                    IDTIPOELEMENTO, 
                    IDORDENAELEMENTO, 
                    CDTPMEDIDAVARIAVEL, 
                    IDELEMENTO AS IDELEMENTO, 
                    IDELEMENTOPAI, 
                    IDSERVOBRIGCOMP, 
                    NRORG, 
                    IDESCOLHIDO, 
                    'E' AS TIPO, 
                    0 AS QTSEGUNDA, 
                    0 AS QTTERCA, 
                    0 AS QTQUARTA, 
                    0 AS QTQUINTA, 
                    0 AS QTSEXTA, 
                    0 AS QTDOMINGO, 
                    0 AS QTSABADO, 
                    0 AS QTMENSAL, 
                    '00:00' AS HRENTRADA, 
                    '00:00' AS HRSAIDA, 
                    0 AS QTFIMSEMANA, 
                    0 AS QTDIAUTIL 
                FROM 
                (
                    SELECT 
                        COMPOSICAO.NRCOMPSERVICO, 
                        COMPOSICAO.NRITCOMPSERVICO, 
                        COMPOSICAO.CDELEMENTO, 
                        COMPOSICAO.NMELEMENTO, 
                        COMPOSICAO.IDTIPOELEMENTO, 
                        COMPOSICAO.IDORDENAELEMENTO, 
                        COMPOSICAO.CDTPMEDIDAVARIAVEL, 
                        COMPOSICAO.IDELEMENTO, 
                        COMPOSICAO.IDELEMENTOPAI, 
                        COMPOSICAO.IDSERVOBRIGCOMP, 
                        COMPOSICAO.NRORG, 
                        'N' AS IDESCOLHIDO 
                    FROM 
                    (
                        SELECT 
                            ITEM.NRCOMPSERVICO, 
                            ITEM.NRITCOMPSERVICO, 
                            ITEM.CDSERVORCA AS CDELEMENTO, 
                            ELEMENTO.NMSERVORCA AS NMELEMENTO, 
                            ELEMENTO.IDTIPOELEMENTO, 
                            ELEMENTO.IDORDENAELEMENTO, 
                            ELEMENTO.CDTPMEDIDAVARIAVEL, 
                            ITEM.IDELEMENTO, 
                            ITEM.IDELEMENTOPAI, 
                            ITESCOPO.NRTIPOORCAMENTO, 
                            ITPRECO.VRPRECO, 
                            ITEM.IDSERVOBRIGCOMP, 
                            ITEM.NRORG 
                        FROM 
                            FCT_ITCOMPSERVICO ITEM
                        INNER JOIN 
                            FCT_SERVICOORCA ELEMENTO 
                            ON ITEM.IDELEMENTO = ELEMENTO.IDELEMENTO 
                            AND ITEM.NRORG = ELEMENTO.NRORG 
                        LEFT JOIN 
                            FCT_RELACSERVICO SERVRELAC 
                            ON ITEM.CDSERVORCA = SERVRELAC.CDSERVORCA 
                            AND ITEM.NRORG = SERVRELAC.NRORG 
                        LEFT JOIN 
                            FCT_ITESCOPOPROPOSTA ITESCOPO 
                            ON SERVRELAC.CDSERVORCARELAC = ITESCOPO.CDSERVORCA 
                            AND SERVRELAC.NRORG = ITESCOPO.NRORG 
                            AND ITESCOPO.NRTIPOORCAMENTO IN (:NRTIPOORCAMENTO)
                        INNER JOIN 
                            FCT_TIPOORCAMENTO ESCOPO 
                            ON ITESCOPO.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO 
                            AND ITESCOPO.NRORG = ESCOPO.NRORG 
                        LEFT JOIN 
                            FCT_ITPRECBASESERV ITPRECO 
                            ON ESCOPO.CDPRECBASESERV = ITPRECO.CDPRECBASESERV 
                            AND ESCOPO.NRORG = ITPRECO.NRORG 
                            AND ITESCOPO.CDSERVORCA = ITPRECO.CDSERVORCA 
                        WHERE 
                            ITEM.NRCOMPSERVICO IN 
                            (
                                SELECT NRCOMPSERVICO 
                                FROM FCT_RELORCAMODCOMPOSICAO 
                                WHERE NRORCAMENTOMODELO = :NRORCAMENTOMODELO
                            ) 
                        ORDER BY ITEM.CDSERVORCA
                    ) COMPOSICAO 
                    GROUP BY 
                        COMPOSICAO.NRCOMPSERVICO, 
                        COMPOSICAO.NRITCOMPSERVICO, 
                        COMPOSICAO.CDELEMENTO, 
                        COMPOSICAO.NMELEMENTO, 
                        COMPOSICAO.IDTIPOELEMENTO, 
                        COMPOSICAO.IDORDENAELEMENTO, 
                        COMPOSICAO.CDTPMEDIDAVARIAVEL, 
                        COMPOSICAO.IDELEMENTO, 
                        COMPOSICAO.IDELEMENTOPAI, 
                        COMPOSICAO.IDSERVOBRIGCOMP, 
                        COMPOSICAO.NRORG 
                    ORDER BY COMPOSICAO.NRITCOMPSERVICO
                )
                ORDER BY IDORDENAELEMENTO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getEscopoFaturamentoProposta($escopos)
    {

        $sql = "SELECT 
                    ESCOPODOC.IDSITUACAOORCAMENTO, 
                    RELAC.NRRELACESCOPOPROPOSTA, 
                    RELAC.NRSEQORCAMENTO, 
                    RELAC.NRTIPOORCAMENTO, 
                    TIPO.NMTIPOORCAMENTO, 
                    ESCOPODOC.NRSEQMODDOCFCT, 
                    MODELO.DSMODELODOCORCA, 
                    RELAC.CDFILIAL, 
                    FILIAL.NMFILIAL, 
                    RELAC.NRORG, 
                    RELAC.DTINCLUSAO, 
                    RELAC.DTULTATU, 
                    RELAC.NRORGINCLUSAO, 
                    RELAC.CDOPERINCLUSAO, 
                    RELAC.NRORGULTATU, 
                    RELAC.CDOPERULTATU, 
                    RELAC.IDATIVO, 
                    TIPO.IDTIPOORCA, 
                    RELAC.DSALTERACONTRATUAIS
                FROM 
                    FCT_RELACESCOPOPROPOSTA RELAC
                INNER JOIN 
                    FCT_TIPOORCAMENTO TIPO ON RELAC.NRTIPOORCAMENTO = TIPO.NRTIPOORCAMENTO 
                                            AND RELAC.NRORG = TIPO.NRORG
                LEFT JOIN 
                    FILIAL ON RELAC.CDFILIAL = FILIAL.CDFILIAL 
                           AND RELAC.NRORG = FILIAL.NRORG
                LEFT JOIN 
                    FCT_ORCAMENTODOC ESCOPODOC ON ESCOPODOC.NRSEQORCAMENTO = RELAC.NRSEQORCAMENTO 
                                               AND ESCOPODOC.NRORG = RELAC.NRORG 
                                               AND ESCOPODOC.NRTIPOORCAMENTO = RELAC.NRTIPOORCAMENTO
                LEFT JOIN 
                    FCT_MODELODOC MODELO ON ESCOPODOC.NRORG = MODELO.NRORG 
                                          AND ESCOPODOC.NRSEQMODDOCFCT = MODELO.NRSEQMODDOCFCT
                WHERE 
                    ESCOPODOC.IDSITUACAOORCAMENTO IN ($escopos) 
                    OR ESCOPODOC.IDSITUACAOORCAMENTO IS NULL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }


    public function getParNegocioProposta()
    {
        $sql = "SELECT DISTINCT 
    PARCNEGOCIO.NRPARCNEGOCIO, 
    PARCNEGOCIO.NMPRINCIPALPARC, 
    PARCNEGOCIO.NMSECUNDARIPARC, 
    PARCNEGOCIO.NRINSCRICAOPARC, 
    PARCNEGOCIO.CDTIPOPARCPRINCIPAL, 
    PARCNEGOCIO.NRORG, 
    PARCNEGOCIO.CDTIPOINSCRICAO, 
    DECODE(PARCNEGOCIO.IDATIVO, 'S', 'Sim', 'Não') AS IDATIVO, 
    OPERADOR.NMOPERADOR AS NMOPERRESPONSAVEL, 
    PARCNEGOCIO.CDIDIOM, 
    IDIOMA.NMIDIOMA, 
    PARCNEGOCIO.NRMOEDA, 
    FCT_MOEDA.NMMOEDA, 
    PARCNEGOCIO.NRPARCNEGOCIO AS NRPARCNEGOCIOFAT, 
    PARCNEGOCIO.NMPRINCIPALPARC AS NMPRINCIPALFAT, 
    PARCNEGOCIO.NMSECUNDARIPARC AS NMSECUNDARIFAT, 
    PARCNEGOCIO.NRINSCRICAOPARC AS NRINSCRICAOFAT 
FROM PARCNEGOCIO 
LEFT JOIN PARCERIA 
    ON PARCNEGOCIO.NRPARCNEGOCIO = PARCERIA.NRPARCNEGOCIO 
    AND PARCNEGOCIO.NRORG = PARCERIA.NRORG 
LEFT JOIN OPERADOR 
    ON PARCNEGOCIO.CDOPERRESPONSAVEL = OPERADOR.CDOPERADOR 
    AND PARCNEGOCIO.NRORG = OPERADOR.NRORG 
LEFT JOIN IDIOMA 
    ON PARCNEGOCIO.CDIDIOM = IDIOMA.CDIDIOM 
LEFT JOIN FCT_MOEDA 
    ON PARCNEGOCIO.NRMOEDA = FCT_MOEDA.NRMOEDA 
LEFT JOIN (
    SELECT * FROM CRM_HIERARQUIAOPER 
    WHERE CDOPERADOR = :P_CDOPERADOR
) OPERHIERAR 
    ON OPERHIERAR.NRORG = PARCNEGOCIO.NRORG 
LEFT JOIN FCT_PARAMETROGERAL PARAM 
    ON PARCNEGOCIO.NRORG = PARAM.NRORG 
WHERE 
    PARCERIA.CDTIPOPARCEIRO IN (:CDTIPOPARCEIRO) 
    AND (
        (PARAM.IDUTILIZAHIEROPER = 'S' 
            AND (
                PARCNEGOCIO.CDOPERRESPONSAVEL IN (
                    SELECT CDOPERADOR 
                    FROM CRM_HIERARQUIAOPER 
                    WHERE (CRM_HIERARQUIAOPER.CDFILIAL = OPERHIERAR.CDFILIAL OR CRM_HIERARQUIAOPER.CDFILIAL IS NULL) 
                    CONNECT BY PRIOR CRM_HIERARQUIAOPER.NRHIERARQUIAOPER = CRM_HIERARQUIAOPER.NRHIERARQUIAPAI 
                    START WITH CRM_HIERARQUIAOPER.CDOPERADOR = OPERHIERAR.CDOPERADOR
                ) 
                OR PARCNEGOCIO.CDOPERRESPONSAVEL IS NULL
            )
        ) 
        OR (OPERHIERAR.IDOPERMASTER = 'S') 
        OR (PARAM.IDUTILIZAHIEROPER = 'N')
    )
ORDER BY PARCNEGOCIO.NMPRINCIPALPARC ASC";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getOperadorResp()
    {
        $sql = "SELECT 
    OPER.CDOPERADOR, 
    UPPER(OPER.NMOPERADOR) AS NMOPERADOR, 
    OPER.NRPARCNEGOCIO, 
    OPER.NRORG, 
    DECODE(OPER.IDATIVO, 'S', 'Sim', 'Não') AS IDATIVO 
FROM OPERADOR OPER 
LEFT JOIN (
    SELECT * FROM CRM_HIERARQUIAOPER 
    WHERE CDOPERADOR = :CDOPERADOR
) HIERARPAI 
    ON OPER.NRORG = HIERARPAI.NRORG 
INNER JOIN FCT_PARAMETROGERAL PARAM 
    ON OPER.NRORG = PARAM.NRORG 
WHERE 
    (PARAM.IDUTILIZAHIEROPER = 'N') 
    OR (PARAM.IDUTILIZAHIEROPER = 'S' 
        AND (
            OPER.CDOPERADOR IN (
                SELECT :CDOPERADOR FROM DUAL 
                UNION ALL 
                SELECT CDOPERADOR 
                FROM CRM_HIERARQUIAOPER 
                WHERE (CRM_HIERARQUIAOPER.CDFILIAL = HIERARPAI.CDFILIAL OR CRM_HIERARQUIAOPER.CDFILIAL IS NULL) 
                CONNECT BY PRIOR CRM_HIERARQUIAOPER.NRHIERARQUIAOPER = CRM_HIERARQUIAOPER.NRHIERARQUIAPAI 
                START WITH CRM_HIERARQUIAOPER.CDOPERADOR = HIERARPAI.CDOPERADOR
            ) 
            OR OPER.CDOPERADOR IS NULL 
            OR OPER.CDOPERADOR = :CDOPERADOR
        )
    ) 
    OR (HIERARPAI.IDOPERMASTER = 'S')
ORDER BY NMOPERADOR ASC";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }


    public function getServicoRelacao($params)
    {
        $sql = "SELECT 
                NRRELACSERVORCA,
                NRSEQORCAMENTO,
                IDESCOLHIDO,
                IDTIPOELEMENTO,
                CDSERVORCA,
                NRCOMPSERVICO,
                VRCUSTOSERV,
                VRTOTMENSALSERV,
                QTSEGUNDA,
                QTTERCA,
                QTQUARTA,
                QTQUINTA,
                QTSEXTA,
                QTSABADO,
                QTDOMINGO,
                QTMENSAL,
                CDTPMEDIDASERV,
                QTMEDSERVORCA,
                IDSERVOBRIGCOMP,
                IDTPDESCORCA,
                VRPERCDESCORCA,
                VRTOTMSLSAJUSTE,
                IDELEMENTO,
                IDELEMENTOPAI,
                NRTIPOORCAMENTO,
                NRORG,
                DTINCLUSAO,
                DTULTATU,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                CDOPERULTATU,
                IDATIVO,
                HRENTRADA,
                HRSAIDA
            FROM FCT_RELACSERVORCAMENTO
     
          ";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }
    public function getTabServicosPropostas($nrtipoorcamento)
    {
        $sql = "SELECT *
                FROM FCT_SERVICOORCA";
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $nrtipoorcamento);
    }
    



    public function getFormacaoPreco()
    {
        $sql = "SELECT NRFORMPRECOSERVICO, NMFORMPRECOSERVICO
                 FROM FCT_FORMPRECOSERVICO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTabFormacaoPreco($params)
    {
        $sql = "SELECT 
                    NRRELACFORMINVEST,
                    NRINVESTIMENTO,
                    NRFORMPRECOSERVICO,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO
                FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRINVESTIMENTO = :NRINVESTIMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getItensTipoElementoProposta(array $params)
    {
        $sql = "SELECT NVL(VRCUSTOSERV, 0) AS VRCUSTOSERV,
                  ELEMENTOS.IDELEMENTOPAI,
                  ELEMENTOS.CDSERVORCA,
                  ELEMENTOS.NRTIPOORCAMENTO,
                  ELEMENTOS.CDTPMEDIDASERV,
                  ELEMENTOS.QTMENSAL,
                  SERV.NMSERVORCA AS NMELEMENTOPAI
            FROM (
                SELECT CDSERVORCA,
                       NVL(VRTOTMENSALSERV, 0) AS VRTOTMENSALSERV,
                       CONNECT_BY_ROOT IDELEMENTO AS IDELEMENTOPAI,
                       NRTIPOORCAMENTO, NRORG,
                       VRCUSTOSERV,
                       QTMENSAL,
                       CDTPMEDIDASERV
                  FROM FCT_RELACSERVORCAMENTO
                CONNECT BY PRIOR IDELEMENTO = IDELEMENTOPAI
                START WITH IDELEMENTO IN (
                    SELECT IDELEMENTO 
                      FROM FCT_RELACSERVORCAMENTO
                     WHERE IDELEMENTOPAI IS NULL
                       AND NRSEQORCAMENTO = :NRSEQORCAMENTO
                       AND NRORG          = :NRORG
                )
            ) ELEMENTOS
            INNER JOIN FCT_SERVICOORCA SERV
              ON ELEMENTOS.CDSERVORCA = SERV.CDSERVORCA
              AND ELEMENTOS.NRORG     = SERV.NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getComposicaoInvestimento($params)
    {
        $sql = "SELECT FCT_RELACSERVINVESTIMENTO.NRRELACSERVINVEST,
            FCT_RELACSERVINVESTIMENTO.NRINVESTIMENTO,
            FCT_RELACSERVINVESTIMENTO.NRCOMPSERVICO,
            FCT_COMPSERVICO.NMCOMPSERVICO,
            FCT_COMPSERVICO.NRCOMPSERVICOPAI,
            COMP_PAI.NMCOMPSERVICO AS NMCOMPSERVICOPAI,
            FCT_RELACSERVINVESTIMENTO.NRORG,
            FCT_RELACSERVINVESTIMENTO.DTINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.NRORGINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.CDOPERINCLUSAO,
            OPINC.NMOPERADOR AS NMOPERINCLUSAO,
            FCT_RELACSERVINVESTIMENTO.DTULTATU,
            FCT_RELACSERVINVESTIMENTO.NRORGULTATU,
            FCT_RELACSERVINVESTIMENTO.CDOPERULTATU,
            OPATU.NMOPERADOR AS NMOPERULTATU,
            FCT_RELACSERVINVESTIMENTO.IDATIVO
        FROM
            FCT_RELACSERVINVESTIMENTO
        INNER JOIN FCT_COMPSERVICO ON FCT_RELACSERVINVESTIMENTO.NRCOMPSERVICO = FCT_COMPSERVICO.NRCOMPSERVICO
        AND FCT_RELACSERVINVESTIMENTO.NRORG = FCT_COMPSERVICO.NRORG
        LEFT JOIN FCT_COMPSERVICO COMP_PAI ON FCT_COMPSERVICO.NRCOMPSERVICOPAI = COMP_PAI.NRCOMPSERVICO
        AND FCT_COMPSERVICO.NRORG = COMP_PAI.NRORG
        LEFT JOIN OPERADOR OPINC ON FCT_RELACSERVINVESTIMENTO.CDOPERINCLUSAO = OPINC.CDOPERADOR
        AND FCT_RELACSERVINVESTIMENTO.NRORG = OPINC.NRORG
        LEFT JOIN OPERADOR OPATU ON FCT_RELACSERVINVESTIMENTO.CDOPERULTATU = OPATU.CDOPERADOR
        AND FCT_RELACSERVINVESTIMENTO.NRORG = OPATU.NRORG
        WHERE FCT_RELACSERVINVESTIMENTO.NRINVESTIMENTO = :NRINVESTIMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }


    public function getInvestimentosPropostaAlimentacao($params)
    {
        $sql = "SELECT *
                FROM FCT_RELACINVESTPROPOSTA
                WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getVrTaxasProposta(array $params)
    {
        if (isset($params['NRSEQORCAMENTO'])) {
            $sql = "SELECT SUM(NVL(TAXA.VRPERCTAXAORC, 0)) AS VRPERCTAXAORC
                    FROM FCT_RELACTAXAPROPOSTA TAXA
                    WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";
        }
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);

    }
    /**
     * Retorna o valor total dos impostos de uma proposta
     **/
    public function getVrImpostosProposta(array $params)
    {
        $sql = "SELECT SUM(NVL(IMPOSTO.VRPERCIMPOSTO, 0)) AS VRPERCIMPOSTO
                FROM FCT_RELACIMPOSTOORCA IMPOSTO
                WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $dataSet = $std->fetchAll();
        return isset($dataSet[0]) ? $dataSet[0]["VRPERCIMPOSTO"] : 0;
    }
    /**
     * Retorna o valor total dos serviços de uma proposta
     **/
    public function getVrServicosProposta(array $params)
    {
        $sql = "SELECT SUM(NVL(SERV.VRTOTALITEMORCA, 0)) AS VRTOTALITEMORCA
                FROM FCT_ITEMORCAMENTO SERV
                JOIN FCT_ORCAMENTO ORC 
                    ON SERV.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                    AND SERV.NRORG         = ORC.NRORG
                WHERE SERV.IDELEMENTO IS NOT NULL
                  AND SERV.NRSEQORCAMENTO = :NRSEQORCAMENTO
                  AND SERV.NRORG          = :NRORG
                GROUP BY ORC.QTDIASVALIDADE";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $dataSet = $std->fetchAll();
        return isset($dataSet[0]) ? $dataSet[0]["VRTOTALITEMORCA"] : 0;
    }
    /**
     * Retorna o valor total dos serviços de uma proposta
     **/
    public function getVrMarkup(array $params)
    {
        $sql = "SELECT NVL(ORC.VRPERCMARKUP, 0) AS VRPERCMARKUP,
                    NVL(ORC.VRPERCMARKUPAPLICADO, 0) AS VRPERCMARKUPAPLICADO
                FROM FCT_ORCAMENTO ORC
                WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO
                  AND NRORG          = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $dataSet = $std->fetchAll();
        return isset($dataSet[0]) ? $dataSet[0] : 0;
    }

    public function getVrMObraProposta(array $params)
    {
        $sql = "SELECT SUM(NVL(FORMPROP.QTFORMACAOPROP, 1) * NVL(ITAUXFORM.VRTOTAL, 0)) AS VRTOTAL
                FROM FCT_CALCFORMPRECSERV_ITPRO ITAUXFORM
                INNER JOIN FCT_RELACFORMACAOPROP FORMPROP
                  ON ITAUXFORM.NRFORMPRECOSERVICO   = FORMPROP.NRFORMPRECOSERVICO
                  AND ITAUXFORM.NRORG               = FORMPROP.NRORG
                  AND ITAUXFORM.NRRELACFORMACAOPROP = FORMPROP.NRRELACFORMACAOPROP
                WHERE FORMPROP.NRSEQORCAMENTO     = :NRSEQORCAMENTO
                    AND FORMPROP.NRORG              = :NRORG
                    AND NRCALCFORMPRECSERVPAI      IS NULL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $dataSet = $std->fetchAll();
        return isset($dataSet[0]) ? $dataSet[0]["VRTOTAL"] : 0;
    }

    public function getVrInvestProposta(array $params)
    {
        $sql = "SELECT SUM(NVL(IVPROP.VRPARCELA, 0)) AS VRPARCELA
                FROM FCT_RELACINVESTPROPOSTA IVPROP
                WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO
                  AND NRORG          = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $dataSet = $std->fetchAll();
        return isset($dataSet[0]) ? $dataSet[0]["VRPARCELA"] : 0;
    }
    /**
     * Retorna o valor total das despesas de uma proposta
     **/
    public function getVrDespesasProposta(array $params)
    {
        $sql = "SELECT SUM(NVL(DESP.VRDESPESAORCA, 0)) AS VRDESPESAORCA
                FROM FCT_RELACDESPPROPOSTA DESP
                WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO
                  AND NRORG          = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $dataSet = $std->fetchAll();
        return isset($dataSet[0]) ? $dataSet[0]["VRDESPESAORCA"] : 0;
    }

    public function getInfoServicosProp(array $params)
    {
        $sql = "SELECT SERVPROP.QTTOTALSERV,
                  SERVPROP.VRCUSTOINFORMADO,
                  SERVPROP.VRCUSTOIDEAL,
                  SERVPROP.VRTOTSERV,
                  SUM(SERVPROP.VRCUSTOSERV) AS VRCUSTOSERV,
                  SERVPROP.NRCOMPSERVICO,
                  SERVPROP.IDELEMENTORAIZ,
                  SUM(SERVPROP.QTTOTALORCA) AS QTTOTALORCA,
                  SERVORCA.NMSERVORCA AS NMELEMENTO,
                  SERVPROP.VRPERCSERVICO,
                  LISTAGG(SERVPROP.NRTIPOORCAMENTO, '_') WITHIN GROUP (ORDER BY SERVPROP.NRTIPOORCAMENTO) AS NRTIPOORCAMENTO,
                  LISTAGG(SERVPROP.CDSERVORCA, '_') WITHIN GROUP (ORDER BY SERVPROP.CDSERVORCA) AS CDSERVORCA
                FROM (SELECT RT.QTTOTALSERV,
                        RT.VRTOTSERV,
                        SERV.VRCUSTOSERV, 
                        RT.VRCUSTOIDEAL,
                        RT.VRCUSTOINFORMADO,
                        SERV.NRORG,
                        SERV.NRCOMPSERVICO,
                        SERV.CDSERVORCA,
                        SERV.NRTIPOORCAMENTO,
                        RT.VRPERCSERVICO,
                        RT.IDELEMENTORAIZ,
                        (SELECT NVL(SUM(QTMENSAL), 0)
                          FROM FCT_RESULTORCALIMENT
                          WHERE NRSEQORCAMENTO = RT.NRSEQORCAMENTO) AS QTTOTALORCA
                      FROM FCT_RELACSERVORCAMENTO SERV
                      INNER JOIN FCT_RESULTORCALIMENT RT
                        ON SERV.NRSEQORCAMENTO = RT.NRSEQORCAMENTO
                        AND SERV.NRORG         = RT.NRORG
                        AND SERV.NRCOMPSERVICO = RT.NRCOMPSERVICORAIZ
                      WHERE SERV.NRSEQORCAMENTO = :NRSEQORCAMENTO
                        AND SERV.NRORG          = :NRORG) SERVPROP
                INNER JOIN FCT_SERVICOORCA SERVORCA
                  ON SERVPROP.IDELEMENTORAIZ = SERVORCA.IDELEMENTO
                  AND SERVPROP.NRORG = SERVORCA.NRORG
                GROUP BY SERVPROP.NRCOMPSERVICO,
                  SERVPROP.IDELEMENTORAIZ,
                  SERVPROP.QTTOTALSERV,
                  SERVORCA.NMSERVORCA,
                  VRCUSTOINFORMADO,
                  VRCUSTOIDEAL,
                  VRTOTSERV,
                  VRPERCSERVICO";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function inserirInvestimento(array $params)
    {
        $sql = "INSERT INTO FCT_RELACINVESTPROPOSTA 
                    (NRINVESTPROP, 
                     NRSEQORCAMENTO,
                     NRINVESTIMENTO,
                     VRUNITINVESTORCA,
                     VRTOTINVETORCA,
                     QTINVESTORCA,
                     VRPARCELA,
                     QTMESARMOTIZACAO,
                     DTINCLUSAO,
                     NRORG,
                     NRORGINCLUSAO,
                     CDOPERINCLUSAO,
                     IDATIVO)
             VALUES (:NRINVESTPROP,
                     :NRSEQORCAMENTO,
                     :NRINVESTIMENTO,
                     :VRUNITINVESTORCA,
                     :VRTOTINVETORCA,
                     :QTINVESTORCA,
                     :VRPARCELA,
                     :QTMESARMOTIZACAO,
                     SYSDATE,
                     :NRORG,
                     :NRORGINCLUSAO,
                     :CDOPERINCLUSAO,
                     :IDATIVO)";
    
        $this->connection->executeStatement($sql, $params);
    }
    
    public function atualizarInvestimento(array $params)
    {
        $sql = "UPDATE FCT_RELACINVESTPROPOSTA SET 
                    NRSEQORCAMENTO = :NRSEQORCAMENTO,
                    NRINVESTIMENTO = :NRINVESTIMENTO,
                    VRUNITINVESTORCA = :VRUNITINVESTORCA,
                    VRTOTINVETORCA = :VRTOTINVETORCA,
                    QTINVESTORCA = :QTINVESTORCA,
                    VRPARCELA = :VRPARCELA,
                    QTMESARMOTIZACAO = :QTMESARMOTIZACAO,
                    DTULTATU = SYSDATE,
                    NRORGULTATU = :NRORGULTATU,
                    CDOPERULTATU = :CDOPERULTATU,
                    IDATIVO = :IDATIVO
                WHERE NRINVESTPROP = :NRINVESTPROP";
    
        $this->connection->executeStatement($sql, $params);
    }
    
    public function atualizarProposta(array $params)
    {
        $sql = "UPDATE FCT_ORCAMENTO SET 
            NRORCAMENTOMODELO = :NRORCAMENTOMODELO,
            NRVERSAOORCAMENTO = :NRVERSAOORCAMENTO,
            DTREFORCAMENTO = :DTREFORCAMENTO,
            IDSITUACAOORCAMENTO = :IDSITUACAOORCAMENTO,
            VRORCAMENTO = :VRORCAMENTO,
            DTACEITEORCA = :DTACEITEORCA,
            NRPARCNEGOCIO = :NRPARCNEGOCIO,
            VRPERCMARKUP = :VRPERCMARKUP,
            QTDIASVALIDADE = :QTDIASVALIDADE,
            DTVALIDADE = :DTVALIDADE,
            NRDIASCARENCIA = :NRDIASCARENCIA,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarCalcFormPrecServ(array $params)
    {
        $sql = "UPDATE FCT_CALCFORMPRECSERV SET 
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRCALCFORMPRECSERV = :NRCALCFORMPRECSERV";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacServOrcamento(array $params)
    {
        $sql = "UPDATE FCT_RELACSERVORCAMENTO SET 
            QTSEGUNDA = :QTSEGUNDA,
            QTTERCA = :QTTERCA,
            QTQUARTA = :QTQUARTA,
            QTQUINTA = :QTQUINTA,
            QTSEXTA = :QTSEXTA,
            QTSABADO = :QTSABADO,
            QTDOMINGO = :QTDOMINGO,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRRELACSERVORCA = :NRRELACSERVORCA";

        $this->connection->executeStatement($sql, $params);
    }
    public function inserirRelacFormacaoProp(array $params)
    {
        $sql = "INSERT INTO FCT_RELACFORMACAOPROP 
                (NRRELACFORMACAOPROP,
                 NRFORMPRECOSERVICO,
                 NRSEQORCAMENTO,
                 NRORG,
                 IDATIVO,
                 DTINCLUSAO,
                 DTULTATU,
                 NRORGINCLUSAO,
                 CDOPERINCLUSAO,
                 NRORGULTATU,
                 CDOPERULTATU,
                 QTFORMACAOPROP,
                 CDSERVORCARELAC)
         VALUES (:NRRELACFORMACAOPROP,
                 :NRFORMPRECOSERVICO,
                 :NRSEQORCAMENTO,
                 :NRORG,
                 :IDATIVO,
                 SYSDATE,
                 SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :NRORGULTATU,
                 :CDOPERULTATU,
                 :QTFORMACAOPROP,
                 :CDSERVORCARELAC)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacFormacaoProp(array $params)
    {
        $sql = "UPDATE FCT_RELACFORMACAOPROP SET 
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO,
            NRSEQORCAMENTO = :NRSEQORCAMENTO,
            NRORG = :NRORG,
            IDATIVO = :IDATIVO,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            QTFORMACAOPROP = :QTFORMACAOPROP,
            CDSERVORCARELAC = :CDSERVORCARELAC
        WHERE NRRELACFORMACAOPROP = :NRRELACFORMACAOPROP";

        $this->connection->executeStatement($sql, $params);
    }
    public function inserirProposta(array $params)
    {
        $sql = "INSERT INTO FCT_ORCAMENTO 
            (NRSEQORCAMENTO, 
             NRORCAMENTOMODELO, 
             NRORCAMENTO,
             NRVERSAOORCAMENTO, 
             DTREFORCAMENTO, 
             IDSITUACAOORCAMENTO, 
             VRORCAMENTO, 
             DTACEITEORCA, 
             NRPARCNEGOCIO, 
             VRPERCMARKUP,  
             QTDIASVALIDADE, 
             DTVALIDADE, 
             NRDIASCARENCIA, 
             NRORG, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             IDATIVO)
    VALUES (:NRSEQORCAMENTO, 
            :NRORCAMENTOMODELO, 
            :NRORCAMENTO,
            :NRVERSAOORCAMENTO, 
            SYSDATE, 
            :IDSITUACAOORCAMENTO, 
            :VRORCAMENTO, 
            SYSDATE, 
            :NRPARCNEGOCIO, 
            :VRPERCMARKUP, 
            :QTDIASVALIDADE, 
            SYSDATE, 
            :NRDIASCARENCIA, 
            :NRORG, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO, 
            :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirRelacServOrcamento(array $params)
    {
        $sql = "INSERT INTO FCT_RELACSERVORCAMENTO 
                (NRRELACSERVORCA,
                NRSEQORCAMENTO,
                IDESCOLHIDO,
                IDTIPOELEMENTO,
                 QTSEGUNDA,
                 QTTERCA,
                 QTQUARTA,
                 QTQUINTA,
                 QTSEXTA,
                 QTSABADO,
                 QTDOMINGO,
                 NRORG,
                 DTINCLUSAO,
                 DTULTATU,
                 NRORGINCLUSAO,
                 CDOPERINCLUSAO,
                 NRORGULTATU,
                 CDOPERULTATU,
                 IDATIVO)
            VALUES (:NRRELACSERVORCA,
                 :NRSEQORCAMENTO,
                 :IDESCOLHIDO,
                 :IDTIPOELEMENTO,
                    :QTSEGUNDA,
                    :QTTERCA,
                    :QTQUARTA,
                    :QTQUINTA,
                    :QTSEXTA,
                    :QTSABADO,
                    :QTDOMINGO,
                    :NRORG,
                    SYSDATE,
                    SYSDATE,
                    :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,
                    :NRORGULTATU,
                    :CDOPERULTATU,
                    :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirImpostoServ(array $params)
    {
        $sql = "INSERT INTO FCT_RELACIMPOSTOSERV 
            (NRIMPOSTOSERV, 
             CDIMPOSTO, 
             VRPERCIMPOSTO, 
             NRCOMPSERVICO, 
             NRORG, 
             IDATIVO, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO)
    VALUES (:NRIMPOSTOSERV, 
            :CDIMPOSTO, 
            :VRPERCIMPOSTO, 
            :NRCOMPSERVICO, 
            :NRORG, 
            :IDATIVO, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirTaxa(array $params)
    {
        $sql = "INSERT INTO FCT_TAXAS 
            (CDTAXA, 
             DSTAXA, 
             VRPERCTAXA, 
             NRORG, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             IDATIVO)
    VALUES (:CDTAXA, 
            :DSTAXA, 
            :VRPERCTAXA, 
            :NRORG, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO, 
            :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarDespesa(array $params)
    {
        $sql = "UPDATE FCT_RELACDESPPROPOSTA SET 
                    NRSEQORCAMENTO = :NRSEQORCAMENTO,
                    CDDESPESA = :CDDESPESA,
                    CDPERIODODESPPROP = :CDPERIODODESPPROP,
                    VRUNITDESPESA = :VRUNITDESPESA,
                    VRDESPESAORCA = :VRDESPESAORCA,
                    DTULTATU = SYSDATE,
                    NRORGULTATU = :NRORGULTATU,
                    CDOPERULTATU = :CDOPERULTATU,
                    IDATIVO = :IDATIVO
                WHERE NRDESPPROP = :NRDESPPROP";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirDespesa(array $params)
    {
        $sql = "INSERT INTO FCT_RELACDESPPROPOSTA 
                    (NRDESPPROP, NRSEQORCAMENTO, CDDESPESA, CDPERIODODESPPROP, VRUNITDESPESA, VRDESPESAORCA, DTINCLUSAO, NRORG, 
                     NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO)
                VALUES (:NRDESPPROP, :NRSEQORCAMENTO, :CDDESPESA, :CDPERIODODESPPROP, :VRUNITDESPESA, :VRDESPESAORCA, SYSDATE, :NRORG, 
                        :NRORGINCLUSAO, :CDOPERINCLUSAO, :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateTabImposto(array $params)
    {
        $sql = "UPDATE FCT_RELACIMPOSTOORCA SET 
                NRSEQORCAMENTO = :NRSEQORCAMENTO,
                VRPERCIMPOSTO = :VRPERCIMPOSTO,
                CDIMPOSTO = :CDIMPOSTO,
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU,
                IDATIVO = :IDATIVO
            WHERE NRIMPOSTOORCA = :NRIMPOSTOORCA";

        $this->connection->executeStatement($sql, $params);
    }



    public function inserirRelacServInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACSERVINVESTIMENTO 
                (NRRELACSERVINVEST, 
                 NRINVESTIMENTO, 
                 NRCOMPSERVICO, 
                 NRCOMPSERVICOPAI, 
                 NRORG, 
                 DTINCLUSAO, 
                 DTULTATU, 
                 NRORGINCLUSAO, 
                 CDOPERINCLUSAO, 
                 NRORGULTATU, 
                 CDOPERULTATU, 
                 IDATIVO, 
                 VRPARCELA, 
                 QTMESARMOTIZACAO)
        VALUES (:NRRELACSERVINVEST, 
                :NRINVESTIMENTO, 
                :NRCOMPSERVICO, 
                :NRCOMPSERVICOPAI, 
                :NRORG, 
                SYSDATE,
                NULL,
                :NRORGINCLUSAO, 
                :CDOPERINCLUSAO,  
                :NRORGULTATU, 
                :CDOPERULTATU, 
                :IDATIVO, 
                :VRPARCELA, 
                :QTMESARMOTIZACAO)";
    
        $this->connection->executeStatement($sql, $params);
    }
    
    public function atualizarRelacServInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACSERVINVESTIMENTO SET 
                NRINVESTIMENTO = :NRINVESTIMENTO, 
                NRCOMPSERVICO = :NRCOMPSERVICO, 
                NRCOMPSERVICOPAI = :NRCOMPSERVICOPAI, 
                NRORG = :NRORG, 
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO,
                VRPARCELA = :VRPARCELA, 
                QTMESARMOTIZACAO = :QTMESARMOTIZACAO
            WHERE NRRELACSERVINVEST = :NRRELACSERVINVEST";
    
        $this->connection->executeStatement($sql, $params);
    }    
    
    public function getInvestimentosPropostaAlimentacao($params)  
    {
        $sql = "SELECT 
                     fi.NRINVESTIMENTO,
                     fi.DSINVESTIMENTO,
                     fi.CDCATINVEST,
                     fc.NMCATINVEST,
                     fi.VRINVESTIMENTO,
                     fi.QTMESARMOTIZACAO,
                     fi.VRPERCJUROS,
                     fi.PERIODOJUROS,
                     fi.TPAMORTIZACAO,
                     fi.DTINCLUSAO,
                     fi.NRORG,
                     fi.DTULTATU,
                     fi.NRORGINCLUSAO,
                     fi.CDOPERINCLUSAO,
                     fi.NRORGULTATU,
                     fi.CDOPERULTATU,
                     fi.IDATIVO
                 FROM FCT_INVESTIMENTO fi
                 LEFT JOIN FCT_CATINVESTIMENTO fc ON fi.CDCATINVEST = fc.CDCATINVEST";
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }    

    public function inserirInvestimento(array $params)
    {
        $sql = "INSERT INTO FCT_INVESTIMENTO 
                    (NRINVESTIMENTO,
                     DSINVESTIMENTO,
                     CDCATINVEST,
                     VRINVESTIMENTO,
                     QTMESARMOTIZACAO,
                     DTINCLUSAO,
                     NRORG,
                     DTULTATU,
                     NRORGINCLUSAO,
                     CDOPERINCLUSAO,
                     NRORGULTATU,
                     CDOPERULTATU,
                     IDATIVO)
             VALUES (:NRINVESTIMENTO,
                     :DSINVESTIMENTO,
                     :CDCATINVEST,
                     :VRINVESTIMENTO,
                     :QTMESARMOTIZACAO,
                     SYSDATE,
                     :NRORG,
                     NULL,
                     :NRORGINCLUSAO,
                     :CDOPERINCLUSAO,
                     NULL,
                     NULL,
                     :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarInvestimento(array $params)
    {
        $sql = "UPDATE FCT_INVESTIMENTO SET 
                DSINVESTIMENTO = :DSINVESTIMENTO,
                CDCATINVEST = :CDCATINVEST,
                VRINVESTIMENTO = :VRINVESTIMENTO,
                QTMESARMOTIZACAO = :QTMESARMOTIZACAO,
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU,
                IDATIVO = :IDATIVO
            WHERE NRINVESTIMENTO = :NRINVESTIMENTO";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarProposta(array $params)
{
    $sql = "UPDATE FCT_ORCAMENTO SET 
            NRORCAMENTOMODELO = :NRORCAMENTOMODELO,
            NRVERSAOORCAMENTO = :NRVERSAOORCAMENTO,
            DTREFORCAMENTO = :DTREFORCAMENTO,
            IDSITUACAOORCAMENTO = :IDSITUACAOORCAMENTO,
            VRORCAMENTO = :VRORCAMENTO,
            DTACEITEORCA = :DTACEITEORCA,
            NRPARCNEGOCIO = :NRPARCNEGOCIO,
            VRPERCMARKUP = :VRPERCMARKUP,
            QTDIASVALIDADE = :QTDIASVALIDADE,
            DTVALIDADE = :DTVALIDADE,
            NRDIASCARENCIA = :NRDIASCARENCIA,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";

    $this->connection->executeStatement($sql, $params);
}

public function atualizarCalcFormPrecServ(array $params)
{
    $sql = "UPDATE FCT_CALCFORMPRECSERV SET 
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRCALCFORMPRECSERV = :NRCALCFORMPRECSERV";

    $this->connection->executeStatement($sql, $params);
}

public function atualizarRelacServOrcamento(array $params)
{
    $sql = "UPDATE FCT_RELACSERVORCAMENTO SET 
            QTSEGUNDA = :QTSEGUNDA,
            QTTERCA = :QTTERCA,
            QTQUARTA = :QTQUARTA,
            QTQUINTA = :QTQUINTA,
            QTSEXTA = :QTSEXTA,
            QTSABADO = :QTSABADO,
            QTDOMINGO = :QTDOMINGO,
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            IDATIVO = :IDATIVO
        WHERE NRRELACSERVORCA = :NRRELACSERVORCA";

    $this->connection->executeStatement($sql, $params);
}
    public function inserirCalcFormPrecServ(array $params)
{
    $sql = "INSERT INTO FCT_CALCFORMPRECSERV 
                (NRCALCFORMPRECSERV,
                 NRFORMPRECOSERVICO,
                 NRORG,
                 DTINCLUSAO,
                 DTULTATU,
                 NRORGINCLUSAO,
                 CDOPERINCLUSAO,
                 NRORGULTATU,
                 CDOPERULTATU,
                 IDATIVO)
         VALUES (:NRCALCFORMPRECSERV,
                 :NRFORMPRECOSERVICO,
                 :NRORG,
                 SYSDATE,
                 SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :NRORGULTATU,
                 :CDOPERULTATU,
                 :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}
    public function inserirProposta(array $params)
{
    $sql = "INSERT INTO FCT_ORCAMENTO 
            (NRSEQORCAMENTO, 
             NRORCAMENTOMODELO, 
             NRVERSAOORCAMENTO, 
             DTREFORCAMENTO, 
             IDSITUACAOORCAMENTO, 
             VRORCAMENTO, 
             DTACEITEORCA, 
             NRPARCNEGOCIO, 
             VRPERCMARKUP,  
             QTDIASVALIDADE, 
             DTVALIDADE, 
             NRDIASCARENCIA, 
             NRORG, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             IDATIVO)
    VALUES (:NRSEQORCAMENTO, 
            :NRORCAMENTOMODELO, 
            :NRVERSAOORCAMENTO, 
            SYSDATE, 
            :IDSITUACAOORCAMENTO, 
            :VRORCAMENTO, 
            SYSDATE, 
            :NRPARCNEGOCIO, 
            :VRPERCMARKUP, 
            :QTDIASVALIDADE, 
            SYSDATE, 
            :NRDIASCARENCIA, 
            :NRORG, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO, 
            :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}

public function inserirRelacServOrcamento(array $params)
{
    $sql = "INSERT INTO FCT_RELACSERVORCAMENTO 
                (NRRELACSERVORCA,
                NRSEQORCAMENTO,
                 QTSEGUNDA,
                 QTTERCA,
                 QTQUARTA,
                 QTQUINTA,
                 QTSEXTA,
                 QTSABADO,
                 QTDOMINGO,
                 NRORG,
                 DTINCLUSAO,
                 DTULTATU,
                 NRORGINCLUSAO,
                 CDOPERINCLUSAO,
                 NRORGULTATU,
                 CDOPERULTATU,
                 IDATIVO)
            VALUES (:NRRELACSERVORCA,
                 :NRSEQORCAMENTO,
                    :QTSEGUNDA,
                    :QTTERCA,
                    :QTQUARTA,
                    :QTQUINTA,
                    :QTSEXTA,
                    :QTSABADO,
                    :QTDOMINGO,
                    :NRORG,
                    SYSDATE,
                    SYSDATE,
                    :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,
                    :NRORGULTATU,
                    :CDOPERULTATU,
                    :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}



public function inserirImpostoServ(array $params)
{
    $sql = "INSERT INTO FCT_RELACIMPOSTOSERV 
            (NRIMPOSTOSERV, 
             CDIMPOSTO, 
             VRPRECIMPOSTO, 
             NRCOMPSERVICO, 
             NRORG, 
             IDATIVO, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO)
    VALUES (:NRIMPOSTOSERV, 
            :CDIMPOSTO, 
            :VRPRECIMPOSTO, 
            :NRCOMPSERVICO, 
            :NRORG, 
            :IDATIVO, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO)";

    $this->connection->executeStatement($sql, $params);
}

public function inserirTaxa(array $params)
{
    $sql = "INSERT INTO FCT_TAXAS 
            (CDTAXA, 
             DSTAXA, 
             VRPERCTAXA, 
             NRORG, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             IDATIVO)
    VALUES (:CDTAXA, 
            :DSTAXA, 
            :VRPERCTAXA, 
            :NRORG, 
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO, 
            :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}

public function atualizarDespesa(array $params) 
{
    $sql = "UPDATE FCT_DESPESA SET 
                DSDESPESA = :DSDESPESA, 
                VRDESPESA = :VRDESPESA, 
                CDPERIODO = :CDPERIODO, 
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
            WHERE CDDESPESA = :CDDESPESA";

    $this->connection->executeStatement($sql, $params);
}

public function inserirDespesa(array $params)
{
    $sql = "INSERT INTO FCT_DESPESA 
                (CDDESPESA, DSDESPESA, VRDESPESA, CDPERIODO, 
                 DTINCLUSAO, NRORG, DTULTATU, NRORGINCLUSAO, 
                 CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
            VALUES (:CDDESPESA, :DSDESPESA, :VRDESPESA, :CDPERIODO, 
                    SYSDATE, :NRORG, NULL, :NRORGINCLUSAO, 
                    :CDOPERINCLUSAO, NULL, NULL, :IDATIVO)";

    $this->connection->executeStatement($sql, $params);
}

    public function inserirRelacServInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACSERVINVESTIMENTO 
                (NRRELACSERVINVEST, 
                 NRINVESTIMENTO, 
                 NRCOMPSERVICO, 
                 NRCOMPSERVICOPAI, 
                 NRORG, 
                 DTINCLUSAO, 
                 DTULTATU, 
                 NRORGINCLUSAO, 
                 CDOPERINCLUSAO, 
                 NRORGULTATU, 
                 CDOPERULTATU, 
                 IDATIVO)
        VALUES (:NRRELACSERVINVEST, 
                :NRINVESTIMENTO, 
                :NRCOMPSERVICO, 
                :NRCOMPSERVICOPAI, 
                :NRORG, 
                SYSDATE,
                NULL,
                :NRORGINCLUSAO, 
                :CDOPERINCLUSAO,  
                :NRORGULTATU, 
                :CDOPERULTATU, 
                :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacServInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACSERVINVESTIMENTO SET 
                NRINVESTIMENTO = :NRINVESTIMENTO, 
                NRCOMPSERVICO = :NRCOMPSERVICO, 
                NRCOMPSERVICOPAI = :NRCOMPSERVICOPAI, 
                NRORG = :NRORG, 
                DTULTATU = SYSDATE,
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
            WHERE NRRELACSERVINVEST = :NRRELACSERVINVEST";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirRelacFormInvest(array $params)
    {
        $sql = "INSERT INTO FCT_RELACFORMINVESTIMENTO 
            (NRRELACFORMINVEST, 
             NRINVESTIMENTO, 
             NRFORMPRECOSERVICO, 
             NRORG, 
             DTINCLUSAO, 
             DTULTATU, 
             NRORGINCLUSAO, 
             CDOPERINCLUSAO, 
             NRORGULTATU, 
             CDOPERULTATU, 
             IDATIVO)
    VALUES (:NRRELACFORMINVEST, 
            :NRINVESTIMENTO, 
            :NRFORMPRECOSERVICO, 
            :NRORG, 
            SYSDATE,
            NULL,
            :NRORGINCLUSAO, 
            :CDOPERINCLUSAO,  
            :NRORGULTATU, 
            :CDOPERULTATU, 
            :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarRelacFormInvest(array $params)
    {
        $sql = "UPDATE FCT_RELACFORMINVESTIMENTO SET 
            NRINVESTIMENTO = :NRINVESTIMENTO, 
            NRFORMPRECOSERVICO = :NRFORMPRECOSERVICO, 
            NRORG = :NRORG, 
            DTULTATU = SYSDATE,
            NRORGULTATU = :NRORGULTATU, 
            CDOPERULTATU = :CDOPERULTATU, 
            IDATIVO = :IDATIVO
        WHERE NRRELACFORMINVEST = :NRRELACFORMINVEST";

        $this->connection->executeStatement($sql, $params);
    }

    public function saveTabImposto(array $params)
    {
        $sql = "INSERT INTO FCT_RELACIMPOSTOORCA 
                    (NRIMPOSTOORCA, NRSEQORCAMENTO, CDIMPOSTO, VRPERCIMPOSTO,
                     NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRIMPOSTOORCA, :NRSEQORCAMENTO, :CDIMPOSTO, :VRPERCIMPOSTO,
                        :NRORG, :IDATIVO, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function verificaExistencia($params)
    {
        // Verifique se os parâmetros estão sendo passados corretamente
        if (isset($params['NRSEQORCAMENTO'])) {
            $sql = "SELECT * 
                    FROM FCT_ORCAMENTO 
                    WHERE NRSEQORCAMENTO = :NRSEQORCAMENTO";

            // Passando os parâmetros corretamente para a consulta
            return $this->connection->executeStatement($sql, ['NRSEQORCAMENTO' => $params['NRSEQORCAMENTO']]);
        }

        // Se o parâmetro 'NRSEQORCAMENTO' não estiver presente, retornar null
        return null;
    }


    //     $sql = "INSERT INTO FCT_RELACIMPOSTOSERV (
    //         NRIMPOSTOSERV, CDIMPOSTO, VRPRECIMPOSTO, NRORG, 
    //         DTINCLUSAO, IDATIVO, NRORGINCLUSAO, CDOPERINCLUSAO
    //     ) VALUES (
    //         :NRIMPOSTOSERV, :CDIMPOSTO, :VRPRECIMPOSTO, :NRORG, 
    //         SYSDATE, :IDATIVO, :NRORGINCLUSAO, :CDOPERINCLUSAO
    //     )";
    
    //     $this->connection->executeStatement($sql, $params);
    // }
    
    // public function updateTabImposto(array $params)
    // {
    //     $sql = "UPDATE FCT_RELACIMPOSTOSERV SET 
    //             CDIMPOSTO = :CDIMPOSTO,
    //             VRPRECIMPOSTO = :VRPRECIMPOSTO,
    //             NRORG = :NRORG,
    //             NRORGULTATU = :NRORGULTATU,
    //             NRORGINCLUSAO = :NRORGINCLUSAO,
    //             CDOPERINCLUSAO = :CDOPERINCLUSAO,
    //             CDOPERULTATU = :CDOPERULTATU,
    //             IDATIVO = :IDATIVO
    //         WHERE NRIMPOSTOSERV = :NRIMPOSTOSERV";
    
    //     $this->connection->executeStatement($sql, $params);
    // }

    public function deleteInvest($parametros)
    {
        $sql2 = "DELETE FROM FCT_RELACFORMINVESTIMENTO
                WHERE NRRELACFORMINVEST IN (" . $parametros . ")";
        $this->connection->executeStatement($sql2);
        $sql1 = "DELETE FROM FCT_RELACSERVINVESTIMENTO
                WHERE NRRELACSERVINVEST IN (" . $parametros . ")";
        $this->connection->executeStatement($sql1);
        $sql = "DELETE FROM  FCT_INVESTIMENTO
                WHERE NRINVESTIMENTO IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deleteComposi($parametros)
    {
        $sql = "DELETE FROM FCT_RELACSERVINVESTIMENTO
                WHERE NRRELACSERVINVEST IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);
    }

    public function deletePropostaAlimenticia($parametros)
    {
        $sql = "DELETE FROM fct_orcamento WHERE NRSEQORCAMENTO IN (" . $parametros . ")";
        $this->connection->executeStatement($sql);
    }

    public function deleteImpostosRelac($parametros)
    {
        $sql = "DELETE FROM FCT_RELACIMPOSTOORCA WHERE NRIMPOSTOORCA IN (" . $parametros . ")";
        $this->connection->executeStatement($sql);
    }

    public function deleteDespesasRelac($parametros)
    {
        $sql = "DELETE FROM FCT_RELACDESPPROPOSTA WHERE NRDESPPROP IN (" . $parametros . ")";
        $this->connection->executeStatement($sql);
    }

    public function deleteInvestimentosRelac($parametros)
    {
        $sql = "DELETE FROM FCT_RELACINVESTPROPOSTA WHERE NRINVESTPROP IN (" . $parametros . ")";
        $this->connection->executeStatement($sql);
    }

    public function deleteMaodeObra($parametros)
    {

        $sql = "DELETE FROM FCT_RELACFORMACAOPROP WHERE NRRELACFORMACAOPROP IN (" . $parametros . ")";
        $this->connection->executeStatement($sql);
    }

    public function deleteServicosRelac($parametros)
    {
        $sql = "DELETE FROM FCT_RELACSERVORCAMENTO WHERE NRRELACSERVORCA IN (" . $parametros . ")";
        $this->connection->executeStatement($sql);
    }

    /**
     * Deleta alguns servicos do imposto
     **/
    public function deleteServicoImposto(array $params, $nrimposto)
    {
        $sql = "DELETE FROM FCT_RELACIMPOSTOSERV
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG
                    AND NRIMPOSTOSERV IN($nrimposto)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    /**
     * Salva a edição de um imposto relacionado a um serviço
     **/
    public function salvarEdicaoImposto(array $params)
    {
        $sql = "UPDATE FCT_RELACIMPOSTOSERV
                SET VRPRECIMPOSTO = :VRPRECIMPOSTO
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}