import {
    Http, IEventParam, Metadata,
} from '@zeedhi/core';
import {
    Button,
    DialogService, Form, LoadingService, Modal, ModalService, Select, SelectMultiple, Textarea, TextInput,
} from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Utilities } from '@/util/Utilities';
import {
    ZdNumber,
    ZdSelect, ZdTextarea, ZdTextInput,
} from '@zeedhi/vuetify';

export class SmPropostasAlimentacaoController {
    public tekgridVisivel: boolean = true;

    public currentRow: any = {};

    public viewTab: boolean = false;

    public tituloHeaderFrameOperadoresEquipes: String = '';

    private ModalFiltro!: Modal;

    get textFrame() {
        return this.currentRow.NRORCAMENTO;
    }

    get formVisivel() {
        return !this.tekgridVisivel;
    }

    get tabInvisivel() {
        return this.currentRow.IDTPMEDIDASERV !== 'F';
    }

    public addNewRowImposto({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRIMPOSTOSERV: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`CDIMPOSTO_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public addNewRowDespesa({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ CDDESPESA: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`DSDESPESA_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public addNewRowInvestimento({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRINVESTIMENTO: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`DSINVESTIMENTO_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public AddNewRowMaoObra({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRCALCFORMPRECSERV: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NRCALCFORMPRECSERV_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public async createModalFiltroElemento() {
        this.ModalFiltro = await ModalService.createFromJson('/investimentos/SmpropostasFiltro', true);
        // this.openModalFiltroElemento();
    }

    public addNewRowImposto({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRIMPOSTOORCA: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NRIMPOSTOORCA_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public recarregarTabs() {
        const voltarButton = Metadata.getInstance<Button>('buttonContinue-4');
        const avancarButton = Metadata.getInstance<Button>('buttonContinue-3');
        const salvarButton = Metadata.getInstance<Button>('buttonContinue-2');

        // Esconder o botão "Voltar" apenas no primeiro step
        voltarButton.isVisible = this.activeStep !== 1;

        // Exibir "Salvar" e esconder "Avançar" apenas no step 9
        if (this.activeStep === 9) {
            salvarButton.isVisible = true;
            avancarButton.isVisible = false;
        } else {
            salvarButton.isVisible = false;
            avancarButton.isVisible = true; // <-- Aqui garantimos que "Avançar" reapareça nos outros steps
        }
    }

    public addNewRowInvestimento({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRINVESTPROP: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NRINVESTPROP_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    // public async carregarEscopoFaturamento(modeloSelecionado: string, ) {
    //     const escopoSelect = Metadata.getInstance<Select>('select-escopo-fatura');

    //     if (!modeloSelecionado) {
    //         escopoSelect.response.data = [];
    //         return;
    //     }

    //     try {
    //         const response = await Http.get(`/findEscopoFaturamento?nrOrcamentoModelo=${modeloSelecionado}`);

    //         if (response && response.data) {
    //             escopoSelect.data = response.data;
    //         }
    //     } catch (error) {
    //         console.error("Erro ao buscar Escopo de Faturamento:", error);
    //         escopoSelect.data = [];
    //     }
    // }

    public closeModalFiltroElemento() {
        this.ModalFiltro.hide();
    }

    public AddNewRowServicos({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRRELACSERVORCA: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NRRELACSERVORCA_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public addNewRow({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRINVESTIMENTO: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`DSINVESTIMENTO_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public addNewRowComposi({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRRELACSERVINVEST: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NRCOMPSERVICO_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public addNewRowFormPreco({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRRELACFORMINVEST: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NRFORMPRECOSERVICO_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public async createModalFiltroElemento() {
        this.ModalFiltro = await ModalService.createFromJson('/investimentos/SmpropostasFiltro', true);
        // this.openModalFiltroElemento();
    }

    public openModalFiltroElemento() {
        this.ModalFiltro.show();
        setTimeout(() => {
            Metadata.getInstance<Select>('filtro-DSINVESTIMENTO').value = this.currentRow.DSINVESTIMENTO;
            Metadata.getInstance<Select>('filtro-categoria').value = this.currentRow.CDCATINVEST;
        }, 200);
    }

    public recarregarTabs() {
        const voltarButton = Metadata.getInstance<Button>('buttonContinue-4');
        const avancarButton = Metadata.getInstance<Button>('buttonContinue-3');
        const salvarButton = Metadata.getInstance<Button>('buttonContinue-2');
        voltarButton.isVisible = this.activeStep !== 1;
        if (this.activeStep === 9) {
            salvarButton.isVisible = true;
            avancarButton.isVisible = false;
        } else {
            salvarButton.isVisible = false;
            avancarButton.isVisible = true;
        }
    }
    
    public closeModalFiltroElemento() {
        this.ModalFiltro.hide();
    }

    public eventFilter({ event }: any) {
        this.openModalFiltroElemento();
        event.preventDefault();
    }

    private clickTimeout: any = null;

    private clicks: number = 0;

    public rowClick({ row, component }: any) {
        this.clicks += 1;

        if (this.clicks === 1) {
            this.clickTimeout = setTimeout(() => {
                if (!component.editing) { // Verifica se não está editando antes de abrir o frame
                    this.currentRow = row;
                    this.tekgridVisivel = false;

                    const tabs = Metadata.getInstance<Tabs>('tabsInformation');

                    // Verifica se a tab já está ativa antes de reabrir
                    if (tabs.activeTab !== 0) {
                        tabs.activeTab = 0;
                    }

                    // Garante que os filtros corretos são aplicados
                    setTimeout(() => {
                        this.setFilterOperadorEquipe();
                        this.setFilterFormpreco();
                    }, 100);
                }

                this.clicks = 0;
            }, 300);
        } else if (this.clicks === 2) {
            clearTimeout(this.clickTimeout);
            component.editing(row);
            this.clicks = 0;
        }
    }

    public setFilterFormpreco() {
        const gridComposicao = Metadata.getInstance<TekGrid>('basic-tek-grid-investimento');
        gridComposicao.datasource.setFilter({
            NRSEQORCAMENTO: this.currentRow.NRSEQORCAMENTO,
        });
    }

    public abrirFrameAdd({ row }: any) {
        this.tekgridVisivel = false;
        this.currentRow = row;
    }

    private fecharFrame() {
        this.tekgridVisivel = true; // Exibir novamente o grid principal
        this.currentRow = null; // Resetar a linha atual para evitar inconsistências
    }

    public async abrirFrame({ row }: any) {
        console.warn('Row recebido:', row);
        this.tekgridVisivel = false;
        this.currentRow = row;
        this.setFilterFormpreco();
        await this.carregarDadosEscopoFaturamentoTabEscopoFaturamento();
    }

    public carregarDadosEscopoFaturamentoTabEscopoFaturamento() {
        console.warn(this.currentRow);
        this.setFilterServicos();
        this.setFilterImpostos();
        this.setFilterMãoObra();
        this.setFilterInvestimentos();
        this.setFilterDespesas();
        this.setFilterMaodeObra();
        Metadata.getInstance<Select>('NRORCAMENTOMODELO').value = this.currentRow.NRORCAMENTOMODELO;
        Metadata.getInstance<Select>('NRTIPOORCAMENTO').value = this.currentRow.NRTIPOORCAMENTO;
        Metadata.getInstance<TextInput>('NRORCAMENTO').value = this.currentRow.NRORCAMENTO;
        Metadata.getInstance<TextInput>('NRVERSAOORCAMENTO').value = this.currentRow.NRVERSAOORCAMENTO;
        Metadata.getInstance<TextInput>('DTREFORCAMENTO').value = this.currentRow.DTREFORCAMENTO || new Date().toISOString().split('T')[0];
        Metadata.getInstance<Select>('IDSITUACAOORCAMENTO').value = this.currentRow.IDSITUACAOORCAMENTO;
        Metadata.getInstance<TextInput>('VRORCAMENTO').value = this.currentRow.VRORCAMENTO;
        Metadata.getInstance<TextInput>('DTACEITEORCA').value = this.currentRow.DTACEITEORCA;
        Metadata.getInstance<Select>('CDOPERRESPONSAVEL').value = this.currentRow.CDOPERRESPONSAVEL;
        Metadata.getInstance<SelectMultiple>('NRPARCNEGOCIO').value = this.currentRow.NRPARCNEGOCIO;
        Metadata.getInstance<TextInput>('NRINSCRICAOPARC').value = this.currentRow.NRINSCRICAOPARC;
        Metadata.getInstance<TextInput>('VRPERCMARKUP').value = this.currentRow.VRPERCMARKUP;
        Metadata.getInstance<SelectMultiple>('DSREFERENCIAORCA').value = this.currentRow.DSREFERENCIAORCA;
        Metadata.getInstance<TextInput>('QTDIASVALIDADE').value = this.currentRow.QTDIASVALIDADE;
        Metadata.getInstance<TextInput>('DTVALIDADE').value = this.currentRow.DTVALIDADE;
        Metadata.getInstance<TextInput>('NRDIASCARENCIA').value = this.currentRow.NRDIASCARENCIA;
        Metadata.getInstance<Textarea>('DSOBSERVACAOORCA').value = this.currentRow.DSOBSERVACAOORCA;
        Metadata.getInstance<Textarea>('DSJUSTIFCANCRENEG').value = this.currentRow.DSJUSTIFCANCRENEG;
    }

    /* eslint-disable */

    public get itensCheckList(): object {
        const itenschecklist = Metadata.getInstance<Select>('IDSITUACAOORCAMENTO');
        return itenschecklist.value;
    }

    public changeModeloProposta({ component }: IEventParam<Select>) {
        const modeloProposta = Metadata.getInstance<Select>('NRORCAMENTOMODELO');
        const escopoFaturamento = Metadata.getInstance<Select>('NRTIPOORCAMENTO');
        escopoFaturamento.value = null;
    
        if (component.value) {
            escopoFaturamento.disabled = false;
            escopoFaturamento.datasource.setFilter({
                NRORCAMENTOMODELO: component.value,
            });
        } else {
            escopoFaturamento.disabled = true;
        }
    }

    public async salvarProposta() {
        const form = Metadata.getInstance<Form>('escopoFaturamentoTab-formRowDadosEscopoFaturamento');
    
        if (Utilities.validateForm(form)) {
            LoadingService.show();
    
            const propostaData = {
                NRSEQORCAMENTO: this.currentRow?.NRSEQORCAMENTO ?? null,
                NRTIPOORCAMENTO: Metadata.getInstance<ZdSelect>('NRTIPOORCAMENTO').value,
                NRORCAMENTOMODELO: Metadata.getInstance<ZdSelect>('NRORCAMENTOMODELO').value,
                NRORCAMENTO: Metadata.getInstance<ZdNumber>('NRORCAMENTO').value,  // ID da proposta
                NRVERSAOORCAMENTO: Metadata.getInstance<ZdNumber>('NRVERSAOORCAMENTO').value,
                DTREFORCAMENTO: Metadata.getInstance<ZdTextInput>('DTREFORCAMENTO').value,
                IDSITUACAOORCAMENTO: Metadata.getInstance<ZdSelect>('IDSITUACAOORCAMENTO').value,
                VRORCAMENTO: Metadata.getInstance<ZdTextInput>('VRORCAMENTO').value,
                DTACEITEORCA: Metadata.getInstance<ZdTextInput>('DTACEITEORCA').value,
                NRPARCNEGOCIO: Metadata.getInstance<Select>('NRPARCNEGOCIO').value,
                NRINSCRICAOPARC: Metadata.getInstance<ZdTextInput>('NRINSCRICAOPARC').value,
                VRPERCMARKUP: Metadata.getInstance<ZdTextInput>('VRPERCMARKUP').value,
                QTDIASVALIDADE: Metadata.getInstance<ZdTextInput>('QTDIASVALIDADE').value,
                DTVALIDADE: Metadata.getInstance<ZdTextInput>('DTVALIDADE').value,
                NRDIASCARENCIA: Metadata.getInstance<ZdTextInput>('NRDIASCARENCIA').value,
                DSOBSERVACAOORCA: Metadata.getInstance<ZdTextarea>('DSOBSERVACAOORCA').value,
                DSJUSTIFCANCRENEG: Metadata.getInstance<ZdTextarea>('DSJUSTIFCANCRENEG').value,
            };
    
            Http.post('/salvarPropostaAlimentacao', propostaData)
                .then(() => {
                    Utilities.showSuccessMessage();
                    this.filtros();
                    // this.tekgridVisivel = true;
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    LoadingService.hide();
                    // this.tekgridVisivel = true;
                });
        }
    }

    // public async salvarServicos() {
    //     const form = Metadata.getInstance<Form>('form-dados-servico-porposta=alimentacao');

    //     if (Utilities.validateForm(form)) {
    //         LoadingService.show();

    //         // Verificar se o NRSEQORCAMENTO está preenchido
    //         const nrseqorcamento = this.currentRow.NRSEQORCAMENTO;
    //         if (!nrseqorcamento) {
    //             Utilities.showErrorMessage('O NRSEQORCAMENTO é obrigatório.');
    //             LoadingService.hide();
    //             return;
    //         }

    //         Http.post('/salvarServicosPropostaAlimentacao', {
    //             NRSEQORCAMENTO: nrseqorcamento, // Garantir que o NRSEQORCAMENTO seja enviado
    //             IDESCOLHIDO: Metadata.getInstance<ZdTextInput>('IDESCOLHIDO').value,
    //             IDTIPOELEMENTO: Metadata.getInstance<ZdTextInput>('IDTIPOELEMENTO').value,
    //             NRRELACSERVORCA: Metadata.getInstance<ZdTextInput>('NRRELACSERVORCA').value,
    //             QTSEGUNDA: Metadata.getInstance<ZdTextInput>('QTSEGUNDA').value,
    //             QTTERCA: Metadata.getInstance<ZdTextInput>('QTTERCA').value,
    //             QTQUARTA: Metadata.getInstance<ZdTextInput>('QTQUARTA').value,
    //             QTQUINTA: Metadata.getInstance<ZdTextInput>('QTQUINTA').value,
    //             QTSEXTA: Metadata.getInstance<ZdTextInput>('QTSEXTA').value,
    //             QTSABADO: Metadata.getInstance<ZdTextInput>('QTSABADO').value,
    //             QTDOMINGO: Metadata.getInstance<ZdTextInput>('QTDOMINGO').value,
    //         })
    //             .then(() => {
    //                 Utilities.showSuccessMessage();
    //             })
    //             .catch((error: any) => {
    //                 Utilities.showErrorMessage(error);
    //             })
    //             .finally(() => {
    //                 LoadingService.hide();
    //             });
    //     }
    // }

    /* eslint-disable */

    public salvarServicos({ component, event }: IEventParam<TekGrid>) {
        event?.preventDefault();

        if (Utilities.validateGrid(component)) {
            LoadingService.show();
            const editedRows = component.getEditedRows();
            if (!editedRows || editedRows.length === 0) {
                Utilities.showErrorMessage("Nenhuma linha editada encontrada!");
                LoadingService.hide();
                return;
            }
            const updatedRows = editedRows.map(row => ({
                ...row,
                NRSEQORCAMENTO: this.currentRow?.NRSEQORCAMENTO ?? null,
            }));
            const sendObject = {
                DRG: updatedRows,
            };
            console.warn("Enviando dados:", sendObject);
            Http.post('/salvarServicosPropostaAlimentacao', sendObject)
                .then(() => {
                    component.datasource.get();
                    Utilities.showSuccessMessage();
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    component.cancelEditedRows();
                    LoadingService.hide();
                });
        }
    }

    public saveTabMaodeObra({ component, event }: IEventParam<TekGrid>) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {
            LoadingService.show();
            const editedRows = component.getEditedRows();
            if (!editedRows || editedRows.length === 0) {
                Utilities.showErrorMessage("Nenhuma linha editada encontrada!");
                LoadingService.hide();
                return;
            }
            const updatedRows = editedRows.map(row => ({
                ...row,
                NRSEQORCAMENTO: this.currentRow?.NRSEQORCAMENTO ?? null,
            }));
            const sendObject = {
                DRG: updatedRows,
            };
            Http.post('/saveTabMaodeObra', sendObject)
                .then(() => {
                    component.datasource.get();
                    Utilities.showSuccessMessage();
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    component.cancelEditedRows();
                    LoadingService.hide();
                });
        }
    }

    public saveFrameInvestimentos({ component, event }: IEventParam<TekGrid>) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {
            LoadingService.show();
    
            const editedRows = component.getEditedRows().map(row => {
                const valorUnitario = parseFloat(row.VRUNITINVESTORCA) || 0;
                const quantidade = parseFloat(row.QTINVESTORCA) || 0;
                const mesesAmortizacao = parseFloat(row.QTMESARMOTIZACAO) || 1;
    
                const valorTotal = valorUnitario * quantidade;
                const valorParcela = mesesAmortizacao > 0 ? valorTotal / mesesAmortizacao : valorTotal;
    
                return {
                    ...row,
                    VRTOTINVETORCA: valorTotal.toFixed(2),
                    VRPARCELA: valorParcela.toFixed(2),
                    NRSEQORCAMENTO: this.currentRow?.NRSEQORCAMENTO ?? null,
                };
            });
    
            const sendObject = { DRG: editedRows };
    
            Http.post('/saveInvestimentoPropostaAlimentacao', sendObject)
                .then(() => {
                    component.datasource.get();
                    Utilities.showSuccessMessage();
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    component.cancelEditedRows();
                    LoadingService.hide();
                });
        }
    }    

    public async saveFrameImposto({ component, event }: IEventParam<TekGrid>) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {
            LoadingService.show();
            const editedRows = component.getEditedRows();
            const updatedRows = editedRows.map(row => ({
                ...row,
                NRSEQORCAMENTO: this.currentRow?.NRSEQORCAMENTO ?? null,
            }));
            const sendObject = {
                DRG: updatedRows,
            };
            Http.post('/saveImpostoPropostaAlimentacao', sendObject)
                .then(() => {
                    component.datasource.get();
                    Utilities.showSuccessMessage();
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    component.cancelEditedRows();
                    LoadingService.hide();
                });
        }
    }

    public saveFrameDespesas({ component, event }: IEventParam<TekGrid>) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {
            LoadingService.show();
            
            const editedRows = component.getEditedRows().map(row => {
                const periodicidade = row.CDPERIODODESPPROP;
                const valorPorPeriodo = parseFloat(row.VRUNITDESPESA) || 0;
                let valorMensal = 0;
    
                switch (periodicidade) {
                    case '1': // Diariamente
                        valorMensal = valorPorPeriodo * 30;
                        break;
                    case '2': // Semanalmente
                        valorMensal = valorPorPeriodo * 4;
                        break;
                    case '3': // Quinzenalmente
                        valorMensal = valorPorPeriodo * 2;
                        break;
                    case '4': // Mensalmente
                        valorMensal = valorPorPeriodo;
                        break;
                    case '5': // Trimestralmente
                        valorMensal = valorPorPeriodo / 3;
                        break;
                    case '6': // Semestralmente
                        valorMensal = valorPorPeriodo / 6;
                        break;
                    case '7': // Anualmente
                        valorMensal = valorPorPeriodo / 12;
                        break;
                }
    
                return {
                    ...row,
                    VRDESPESAORCA: valorMensal.toFixed(2),
                    NRSEQORCAMENTO: this.currentRow?.NRSEQORCAMENTO ?? null,
                };
            });
    
            const sendObject = { DRG: editedRows };
            
            Http.post('/saveDespesasPropostaAlimentacao', sendObject)
                .then(() => {
                    component.datasource.get();
                    Utilities.showSuccessMessage();
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    component.cancelEditedRows();
                    LoadingService.hide();
                });
        }
    }    

    /* eslint-enable */

    public filtrarElemento() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-investimento');
        const form = Metadata.getInstance<Form>('form-filter');

        const selectedInvestimentos = Metadata.getInstance<SelectMultiple>('filtro-DSINVESTIMENTO').value;
        const selectedCategorias = Metadata.getInstance<SelectMultiple>('filtro-categoria').value;

        // Buscar os nomes dos investimentos selecionados
        const investimentosSelecionados = Metadata.getInstance<SelectMultiple>('filtro-DSINVESTIMENTO')
            .datasource.data
            .filter((item: any) => selectedInvestimentos.includes(item.NRINVESTIMENTO))
            .map((item: any) => item.DSINVESTIMENTO);

        this.currentRow.CDCATINVEST = selectedCategorias;
        this.currentRow.DSINVESTIMENTO = investimentosSelecionados;

        if (Utilities.validateForm(form)) {
            grid.datasource.setFilter({
                CDCATINVEST: this.currentRow.CDCATINVEST,
                DSINVESTIMENTO: this.currentRow.DSINVESTIMENTO,
            });
            this.ModalFiltro.hide();
        }
    }

    public activeStep: number = 1;

    public steps: number = 9;

    public step: number = 1;

    /* eslint-disable */

    public nextStep() {
        if (this.activeStep < this.steps) {
            this.activeStep++;
        }
        this.recarregarTabs();
    }

    public backStep() {
        if (this.activeStep > 1) {
            this.activeStep--;
        }
        this.recarregarTabs(); // Atualiza a visibilidade dos botões
    }

    /* eslint-enable */

    public limparCampos() {
        Metadata.getInstance<Form>('form-filter').clearForm();
    }

    public verificaTab() {
        const tabs = Metadata.getInstance<Tabs>('tabsInformation');
        const tabAtiva = tabs.activeTab;

        if (tabs.tabs[tabAtiva].name === 'tab_variacao') {
            this.carregarDadosAbaVariacao();
        }
    }

    public voltarTekGrid() {
        this.tekgridVisivel = true;
    }

    public setFilterOperadorEquipe() {
        const gridOperador = Metadata.getInstance<TekGrid>('tab-composi');
        gridOperador.datasource.setFilter({
            NRINVESTIMENTO: this.currentRow.NRINVESTIMENTO,
        });
    }

    public investimentoTabComposicoes() {
        console.warn('entrou');
        const grid = Metadata.getInstance<TekGrid>('tab-composi');
        grid.datasource.setFilter({
            NRINVESTIMENTO: this.currentRow.NRINVESTIMENTO,
        });
        console.warn('ede');
    }

    public carregarDadosAbaVariacao() {
        const cdtpmedidaserv = this.currentRow.NRIMPOSTOSERV;
        try {
            const grid = Metadata.getInstance<TekGrid>('tabcomposi');
            grid.datasource.setFilter({
                CDIMPOSTO: cdtpmedidaserv,
            });
        } catch (e) {
            // console.log(e);
        }
    }

    public carregarDadosAbaTipoMedida() {
        Metadata.getInstance<Select>('CDIMPOSTO').value = this.currentRow.CDIMPOSTO;
        Metadata.getInstance<TextInput>('VRPRECIMPOSTO').value = this.currentRow.VRPRECIMPOSTO;
        Metadata.getInstance<Select>('NRCOMPSERVICO').value = this.currentRow.NRCOMPSERVICO;
    }

    public saveInvestimentos({ component, event }: IEventParam<TekGrid>) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {
            LoadingService.show();
            const sendObject = {
                DRG: component.getEditedRows(),
            };
            Http.post('/saveInvestimentos', sendObject).then(() => {
                component.datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
                LoadingService.hide();
            }).finally(() => {
                component.cancelEditedRows();
                LoadingService.hide();
            });
        }
    }
    /* eslint-disable */

    public saveComposiServ({ component, event }: IEventParam<TekGrid>, nr: any) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {
            LoadingService.show();
            const editedRows = component.getEditedRows().map(row => ({
                ...row,
                NRINVESTIMENTO: this.currentRow.NRINVESTIMENTO,
            }));
            const sendObject = {
                DRG: editedRows
            };
            Http.post('/saveComposicaoInvest', sendObject)
                .then(() => {
                    component.datasource.get();
                    Utilities.showSuccessMessage();
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    component.cancelEditedRows();
                    LoadingService.hide();
                });
        }
    }

    public saveFormPreco({ component, event }: IEventParam<TekGrid>, nr: any) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {
            LoadingService.show();
            const editedRows = component.getEditedRows().map(row => ({
                ...row,
                NRINVESTPROP: this.currentRow.NRINVESTPROP,
            }));
            const sendObject = {
                DRG: editedRows
            };
            Http.post('/saveRelacFormInvest', sendObject)
                .then(() => {
                    component.datasource.get();
                    Utilities.showSuccessMessage();
                })
                .catch((error: any) => {
                    Utilities.showErrorMessage(error);
                })
                .finally(() => {
                    component.cancelEditedRows();
                    LoadingService.hide();
                });
        }
    }

    /* eslint-enable */

    public showDialogWithButtonsGrid({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'SmPropostasInvestimentosController.deleteInvest');
    }

    public deleteInvest() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-investimento');
        LoadingService.show();
        Http.post('/deleteInvest', {
            NRS: grid.selectedRows.map((element: any) => element.NRINVESTIMENTO),
        }).then(() => {
            grid.selectedRows = [];
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public showDialogBeforeDelete({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'SmPropostasAlimentacaoController.deletePropostaAlimentcia');
    }

    public deletePropostaAlimentcia() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-propostas-alimentacao');
        LoadingService.show();
        Http.post('/deletePropostaAlimenticia', {
            NRS: grid.selectedRows.map((element: any) => element.NRSEQORCAMENTO),
        }).then(() => {
            grid.selectedRows = [];
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
            DialogService.hide();
        });
    }
}